
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         sparql_parser_parse
#define yylex           sparql_parser_lex
#define yyerror         sparql_parser_error
#define yylval          sparql_parser_lval
#define yychar          sparql_parser_char
#define yydebug         sparql_parser_debug
#define yynerrs         sparql_parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 28 "./sparql_parser.y"

#ifdef HAVE_CONFIG_H
#include <rasqal_config.h>
#endif

#ifdef WIN32
#include <win32_rasqal_config.h>
#endif

#include <stdio.h>
#include <stdarg.h>

#include <rasqal.h>
#include <rasqal_internal.h>

#include <sparql_parser.h>

#define YY_DECL int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t yyscanner)
#define YY_NO_UNISTD_H 1
#include <sparql_lexer.h>

#include <sparql_common.h>


/* Set RASQAL_DEBUG to 3 for super verbose parsing - watching the shift/reduces */
#if 0
#undef RASQAL_DEBUG
#define RASQAL_DEBUG 3
#endif


#define DEBUG_FH stderr

/* Make verbose error messages for syntax errors */
#define YYERROR_VERBOSE 1

/* Fail with an debug error message if RASQAL_DEBUG > 1 */
#if RASQAL_DEBUG > 1
#define YYERROR_MSG(msg) do { fputs("** YYERROR ", DEBUG_FH); fputs(msg, DEBUG_FH); fputc('\n', DEBUG_FH); YYERROR; } while(0)
#else
#define YYERROR_MSG(ignore) YYERROR
#endif

/* Slow down the grammar operation and watch it work */
#if RASQAL_DEBUG > 2
#define YYDEBUG 1
#endif

/* the lexer does not seem to track this */
#undef RASQAL_SPARQL_USE_ERROR_COLUMNS

/* Missing sparql_lexer.c/h prototypes */
int sparql_lexer_get_column(yyscan_t yyscanner);
/* Not used here */
/* void sparql_lexer_set_column(int  column_no , yyscan_t yyscanner);*/


/* What the lexer wants */
extern int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t scanner);
#define YYLEX_PARAM ((rasqal_sparql_query_language*)(((rasqal_query*)rq)->context))->scanner

/* Pure parser argument (a void*) */
#define YYPARSE_PARAM rq

/* Make the yyerror below use the rdf_parser */
#undef yyerror
#define yyerror(message) sparql_query_error((rasqal_query*)rq, message)

/* Make lex/yacc interface as small as possible */
#undef yylex
#define yylex sparql_lexer_lex


static int sparql_parse(rasqal_query* rq);
static void sparql_query_error(rasqal_query* rq, const char *message);
static void sparql_query_error_full(rasqal_query *rq, const char *message, ...) RASQAL_PRINTF_FORMAT(2, 3);

static sparql_uri_applies*
new_uri_applies(raptor_uri* uri, rasqal_update_graph_applies applies) 
{
  sparql_uri_applies* ua;

  ua = RASQAL_MALLOC(sparql_uri_applies*, sizeof(*ua));
  if(!ua)
    return NULL;
  
  ua->uri = uri;
  ua->applies = applies;

  return ua;
}


static void
free_uri_applies(sparql_uri_applies* ua)
{
  if(ua->uri)
    raptor_free_uri(ua->uri);
}





/* Line 189 of yacc.c  */
#line 186 "sparql_parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SELECT = 258,
     FROM = 259,
     WHERE = 260,
     OPTIONAL = 261,
     DESCRIBE = 262,
     CONSTRUCT = 263,
     ASK = 264,
     DISTINCT = 265,
     REDUCED = 266,
     LIMIT = 267,
     UNION = 268,
     PREFIX = 269,
     BASE = 270,
     BOUND = 271,
     GRAPH = 272,
     NAMED = 273,
     FILTER = 274,
     OFFSET = 275,
     ORDER = 276,
     BY = 277,
     REGEX = 278,
     ASC = 279,
     DESC = 280,
     LANGMATCHES = 281,
     A = 282,
     STRLANG = 283,
     STRDT = 284,
     STR = 285,
     IRI = 286,
     URI = 287,
     BNODE = 288,
     LANG = 289,
     DATATYPE = 290,
     ISURI = 291,
     ISBLANK = 292,
     ISLITERAL = 293,
     ISNUMERIC = 294,
     SAMETERM = 295,
     GROUP = 296,
     HAVING = 297,
     COUNT = 298,
     SUM = 299,
     AVG = 300,
     MIN = 301,
     MAX = 302,
     GROUP_CONCAT = 303,
     SAMPLE = 304,
     SEPARATOR = 305,
     DELETE = 306,
     INSERT = 307,
     WITH = 308,
     CLEAR = 309,
     CREATE = 310,
     SILENT = 311,
     DATA = 312,
     DROP = 313,
     LOAD = 314,
     INTO = 315,
     DEFAULT = 316,
     TO = 317,
     ADD = 318,
     MOVE = 319,
     COPY = 320,
     ALL = 321,
     COALESCE = 322,
     AS = 323,
     IF = 324,
     NOT = 325,
     IN = 326,
     BINDINGS = 327,
     UNDEF = 328,
     SERVICE = 329,
     MINUS = 330,
     YEAR = 331,
     MONTH = 332,
     DAY = 333,
     HOURS = 334,
     MINUTES = 335,
     SECONDS = 336,
     TIMEZONE = 337,
     TZ = 338,
     STRLEN = 339,
     SUBSTR = 340,
     UCASE = 341,
     LCASE = 342,
     STRSTARTS = 343,
     STRENDS = 344,
     CONTAINS = 345,
     ENCODE_FOR_URI = 346,
     CONCAT = 347,
     STRBEFORE = 348,
     STRAFTER = 349,
     REPLACE = 350,
     BIND = 351,
     ABS = 352,
     ROUND = 353,
     CEIL = 354,
     FLOOR = 355,
     RAND = 356,
     MD5 = 357,
     SHA1 = 358,
     SHA224 = 359,
     SHA256 = 360,
     SHA384 = 361,
     SHA512 = 362,
     EXPLAIN = 363,
     LET = 364,
     CURRENT_DATETIME = 365,
     NOW = 366,
     FROM_UNIXTIME = 367,
     TO_UNIXTIME = 368,
     HATHAT = 369,
     SC_OR = 370,
     SC_AND = 371,
     EQ = 372,
     NEQ = 373,
     LT = 374,
     GT = 375,
     LE = 376,
     GE = 377,
     ASSIGN = 378,
     STRING = 379,
     LANG_TAG = 380,
     DOUBLE_LITERAL = 381,
     DOUBLE_POSITIVE_LITERAL = 382,
     DOUBLE_NEGATIVE_LITERAL = 383,
     INTEGER_LITERAL = 384,
     INTEGER_POSITIVE_LITERAL = 385,
     INTEGER_NEGATIVE_LITERAL = 386,
     DECIMAL_LITERAL = 387,
     DECIMAL_POSITIVE_LITERAL = 388,
     DECIMAL_NEGATIVE_LITERAL = 389,
     BOOLEAN_LITERAL = 390,
     URI_LITERAL = 391,
     URI_LITERAL_BRACE = 392,
     QNAME_LITERAL = 393,
     QNAME_LITERAL_BRACE = 394,
     BLANK_LITERAL = 395,
     IDENTIFIER = 396
   };
#endif
/* Tokens.  */
#define SELECT 258
#define FROM 259
#define WHERE 260
#define OPTIONAL 261
#define DESCRIBE 262
#define CONSTRUCT 263
#define ASK 264
#define DISTINCT 265
#define REDUCED 266
#define LIMIT 267
#define UNION 268
#define PREFIX 269
#define BASE 270
#define BOUND 271
#define GRAPH 272
#define NAMED 273
#define FILTER 274
#define OFFSET 275
#define ORDER 276
#define BY 277
#define REGEX 278
#define ASC 279
#define DESC 280
#define LANGMATCHES 281
#define A 282
#define STRLANG 283
#define STRDT 284
#define STR 285
#define IRI 286
#define URI 287
#define BNODE 288
#define LANG 289
#define DATATYPE 290
#define ISURI 291
#define ISBLANK 292
#define ISLITERAL 293
#define ISNUMERIC 294
#define SAMETERM 295
#define GROUP 296
#define HAVING 297
#define COUNT 298
#define SUM 299
#define AVG 300
#define MIN 301
#define MAX 302
#define GROUP_CONCAT 303
#define SAMPLE 304
#define SEPARATOR 305
#define DELETE 306
#define INSERT 307
#define WITH 308
#define CLEAR 309
#define CREATE 310
#define SILENT 311
#define DATA 312
#define DROP 313
#define LOAD 314
#define INTO 315
#define DEFAULT 316
#define TO 317
#define ADD 318
#define MOVE 319
#define COPY 320
#define ALL 321
#define COALESCE 322
#define AS 323
#define IF 324
#define NOT 325
#define IN 326
#define BINDINGS 327
#define UNDEF 328
#define SERVICE 329
#define MINUS 330
#define YEAR 331
#define MONTH 332
#define DAY 333
#define HOURS 334
#define MINUTES 335
#define SECONDS 336
#define TIMEZONE 337
#define TZ 338
#define STRLEN 339
#define SUBSTR 340
#define UCASE 341
#define LCASE 342
#define STRSTARTS 343
#define STRENDS 344
#define CONTAINS 345
#define ENCODE_FOR_URI 346
#define CONCAT 347
#define STRBEFORE 348
#define STRAFTER 349
#define REPLACE 350
#define BIND 351
#define ABS 352
#define ROUND 353
#define CEIL 354
#define FLOOR 355
#define RAND 356
#define MD5 357
#define SHA1 358
#define SHA224 359
#define SHA256 360
#define SHA384 361
#define SHA512 362
#define EXPLAIN 363
#define LET 364
#define CURRENT_DATETIME 365
#define NOW 366
#define FROM_UNIXTIME 367
#define TO_UNIXTIME 368
#define HATHAT 369
#define SC_OR 370
#define SC_AND 371
#define EQ 372
#define NEQ 373
#define LT 374
#define GT 375
#define LE 376
#define GE 377
#define ASSIGN 378
#define STRING 379
#define LANG_TAG 380
#define DOUBLE_LITERAL 381
#define DOUBLE_POSITIVE_LITERAL 382
#define DOUBLE_NEGATIVE_LITERAL 383
#define INTEGER_LITERAL 384
#define INTEGER_POSITIVE_LITERAL 385
#define INTEGER_NEGATIVE_LITERAL 386
#define DECIMAL_LITERAL 387
#define DECIMAL_POSITIVE_LITERAL 388
#define DECIMAL_NEGATIVE_LITERAL 389
#define BOOLEAN_LITERAL 390
#define URI_LITERAL 391
#define URI_LITERAL_BRACE 392
#define QNAME_LITERAL 393
#define QNAME_LITERAL_BRACE 394
#define BLANK_LITERAL 395
#define IDENTIFIER 396




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 140 "./sparql_parser.y"

  raptor_sequence *seq;
  rasqal_variable *variable;
  rasqal_literal *literal;
  rasqal_triple *triple;
  rasqal_expression *expr;
  rasqal_graph_pattern *graph_pattern;
  double floating;
  raptor_uri *uri;
  unsigned char *name;
  rasqal_formula *formula;
  rasqal_update_operation *update;
  unsigned int uinteger;
  rasqal_data_graph* data_graph;
  rasqal_row* row;
  rasqal_solution_modifier* modifier;
  int limit_offset[2];
  int integer;
  rasqal_projection* projection;
  rasqal_bindings* bindings;
  sparql_uri_applies* uri_applies;



/* Line 214 of yacc.c  */
#line 529 "sparql_parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 541 "sparql_parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2229

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  158
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  150
/* YYNRULES -- Number of rules.  */
#define YYNRULES  379
/* YYNRULES -- Number of states.  */
#define YYNSTATES  788

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   396

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   157,     2,     2,   122,     2,     2,     2,
     115,   116,   134,   132,   114,   133,   156,   135,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   155,
       2,     2,     2,   121,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   117,     2,   118,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,     2,   120,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    12,    14,    15,    17,    19,
      21,    23,    27,    30,    32,    33,    35,    37,    39,    41,
      43,    45,    47,    49,    51,    53,    56,    59,    60,    65,
      66,    71,    75,    79,    83,    86,    88,    90,    93,    97,
      99,   101,   107,   109,   111,   113,   115,   117,   119,   121,
     123,   124,   126,   128,   134,   140,   146,   152,   158,   163,
     164,   168,   170,   177,   183,   189,   197,   203,   209,   212,
     216,   218,   222,   225,   228,   231,   235,   241,   247,   251,
     253,   259,   265,   267,   269,   272,   274,   278,   284,   290,
     302,   310,   318,   326,   328,   330,   332,   334,   337,   341,
     343,   345,   346,   350,   354,   358,   361,   363,   365,   367,
     369,   371,   373,   377,   383,   389,   395,   401,   404,   406,
     408,   409,   411,   414,   416,   419,   421,   423,   424,   429,
     432,   434,   437,   438,   440,   442,   447,   449,   453,   454,
     456,   459,   461,   464,   465,   468,   471,   473,   475,   476,
     480,   481,   484,   486,   489,   492,   494,   496,   498,   500,
     503,   506,   512,   513,   516,   518,   520,   521,   524,   526,
     530,   533,   536,   538,   540,   543,   547,   549,   551,   553,
     555,   557,   561,   565,   568,   570,   571,   574,   576,   577,
     581,   583,   585,   587,   588,   592,   594,   596,   598,   600,
     602,   604,   606,   608,   611,   615,   620,   623,   627,   629,
     633,   635,   642,   649,   652,   654,   656,   658,   660,   661,
     668,   672,   675,   679,   683,   685,   686,   690,   692,   693,
     697,   699,   702,   705,   709,   712,   713,   715,   716,   719,
     722,   723,   725,   727,   729,   731,   733,   737,   741,   744,
     746,   748,   750,   752,   754,   756,   758,   761,   764,   766,
     769,   772,   774,   776,   778,   780,   782,   784,   787,   789,
     793,   795,   799,   801,   805,   809,   813,   817,   821,   825,
     829,   834,   836,   840,   844,   847,   850,   852,   856,   860,
     862,   865,   868,   871,   873,   875,   877,   879,   881,   883,
     885,   889,   894,   899,   906,   911,   916,   921,   926,   931,
     935,   939,   944,   949,   954,   959,   964,   969,   974,   979,
     984,   989,   991,   993,  1002,  1009,  1016,  1023,  1028,  1033,
    1038,  1043,  1045,  1047,  1049,  1054,  1061,  1070,  1075,  1080,
    1087,  1094,  1101,  1106,  1111,  1118,  1125,  1134,  1145,  1152,
    1161,  1166,  1171,  1176,  1181,  1186,  1191,  1196,  1201,  1205,
    1209,  1214,  1219,  1221,  1223,  1225,  1227,  1229,  1231,  1233,
    1235,  1237,  1239,  1241,  1243,  1245,  1247,  1249,  1251,  1253
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     159,     0,    -1,   160,    -1,   163,    -1,   166,   161,   162,
     233,    -1,   108,    -1,    -1,   169,    -1,   187,    -1,   188,
      -1,   190,    -1,   166,   165,   164,    -1,   155,   163,    -1,
     155,    -1,    -1,   193,    -1,   198,    -1,   199,    -1,   201,
      -1,   203,    -1,   204,    -1,   208,    -1,   209,    -1,   210,
      -1,   211,    -1,   167,   168,    -1,    15,   149,    -1,    -1,
     168,    14,   154,   149,    -1,    -1,   171,   213,   217,   219,
      -1,   171,   217,   219,    -1,     3,    10,   172,    -1,     3,
      11,   172,    -1,     3,   172,    -1,   173,    -1,   134,    -1,
     173,   174,    -1,   173,   114,   174,    -1,   174,    -1,   283,
      -1,   115,   287,    68,   285,   116,    -1,   178,    -1,   179,
      -1,   180,    -1,   181,    -1,   182,    -1,   185,    -1,   186,
      -1,    10,    -1,    -1,   287,    -1,   134,    -1,    43,   115,
     176,   177,   116,    -1,    44,   115,   176,   287,   116,    -1,
      45,   115,   176,   287,   116,    -1,    46,   115,   176,   287,
     116,    -1,    47,   115,   176,   287,   116,    -1,   155,    50,
     126,   137,    -1,    -1,   184,   114,   287,    -1,   287,    -1,
      48,   115,   176,   184,   183,   116,    -1,    49,   115,   176,
     287,   116,    -1,     8,   265,   213,   217,   219,    -1,     8,
     213,     5,   119,   267,   120,   219,    -1,     7,   189,   213,
     218,   219,    -1,     7,   134,   213,   218,   219,    -1,   189,
     282,    -1,   189,   114,   282,    -1,   282,    -1,     9,   213,
     217,    -1,     4,   214,    -1,     4,   215,    -1,    17,   149,
      -1,    51,   212,   218,    -1,    51,   119,   197,   120,   217,
      -1,    51,    57,   119,   194,   120,    -1,    51,     5,   241,
      -1,   248,    -1,    17,   149,   119,   248,   120,    -1,    17,
     282,   119,   267,   120,    -1,   267,    -1,   195,    -1,   197,
     196,    -1,   196,    -1,    52,   212,   218,    -1,    52,   119,
     197,   120,   218,    -1,    52,    57,   119,   194,   120,    -1,
      53,   149,    51,   119,   197,   120,    52,   119,   197,   120,
     218,    -1,    53,   149,    51,   119,   197,   120,   218,    -1,
      53,   149,    52,   119,   197,   120,   218,    -1,    53,   149,
      52,    57,   119,   194,   120,    -1,   192,    -1,    61,    -1,
      18,    -1,    66,    -1,    17,    61,    -1,    54,   202,   200,
      -1,    54,    -1,    56,    -1,    -1,    55,   202,   149,    -1,
      55,   202,   192,    -1,    58,   202,   200,    -1,   205,   149,
      -1,   149,    -1,    61,    -1,   149,    -1,   192,    -1,   149,
      -1,    61,    -1,    59,   202,   149,    -1,    59,   202,   205,
      60,   207,    -1,    63,   202,   206,    62,   206,    -1,    64,
     202,   206,    62,   206,    -1,    65,   202,   206,    62,   206,
      -1,   212,   191,    -1,   191,    -1,   212,    -1,    -1,   216,
      -1,    18,   216,    -1,   306,    -1,     5,   241,    -1,   241,
      -1,   217,    -1,    -1,   223,   226,   228,   227,    -1,   220,
     222,    -1,   222,    -1,    68,   283,    -1,    -1,   296,    -1,
     261,    -1,   115,   287,   221,   116,    -1,   283,    -1,    41,
      22,   220,    -1,    -1,   259,    -1,   225,   224,    -1,   224,
      -1,    42,   225,    -1,    -1,   231,   232,    -1,   232,   231,
      -1,   231,    -1,   232,    -1,    -1,    21,    22,   229,    -1,
      -1,   229,   230,    -1,   230,    -1,    24,   295,    -1,    25,
     295,    -1,   261,    -1,   283,    -1,   295,    -1,   296,    -1,
      12,   142,    -1,    20,   142,    -1,    72,   234,   119,   235,
     120,    -1,    -1,   234,   283,    -1,   283,    -1,   236,    -1,
      -1,   236,   237,    -1,   237,    -1,   115,   238,   116,    -1,
     115,   116,    -1,   238,   240,    -1,   240,    -1,   137,    -1,
     137,   138,    -1,   137,   123,   306,    -1,   306,    -1,   239,
      -1,   302,    -1,   148,    -1,    73,    -1,   119,   170,   120,
      -1,   119,   242,   120,    -1,   243,   244,    -1,   248,    -1,
      -1,   244,   245,    -1,   245,    -1,    -1,   246,   247,   243,
      -1,   249,    -1,   258,    -1,   156,    -1,    -1,   268,   156,
     243,    -1,   268,    -1,   254,    -1,   250,    -1,   253,    -1,
     251,    -1,   252,    -1,   256,    -1,   257,    -1,     6,   241,
      -1,    17,   282,   241,    -1,    74,   202,   282,   241,    -1,
      75,   241,    -1,   241,    13,   255,    -1,   241,    -1,   255,
      13,   241,    -1,   241,    -1,   109,   115,   283,   136,   287,
     116,    -1,    96,   115,   287,    68,   283,   116,    -1,    19,
     259,    -1,   295,    -1,   296,    -1,   261,    -1,   155,    -1,
      -1,   306,   115,   176,   264,   260,   116,    -1,   301,   264,
     116,    -1,    67,   263,    -1,   115,   264,   116,    -1,   264,
     114,   287,    -1,   287,    -1,    -1,   119,   266,   120,    -1,
     267,    -1,    -1,   268,   156,   266,    -1,   268,    -1,   281,
     269,    -1,   276,   271,    -1,   275,   272,   270,    -1,   155,
     271,    -1,    -1,   269,    -1,    -1,   274,   273,    -1,   114,
     272,    -1,    -1,   280,    -1,   282,    -1,    27,    -1,   278,
      -1,   277,    -1,   117,   269,   118,    -1,   115,   279,   116,
      -1,   279,   280,    -1,   280,    -1,   281,    -1,   276,    -1,
     283,    -1,   286,    -1,   283,    -1,   306,    -1,   121,   284,
      -1,   122,   284,    -1,   154,    -1,   121,   284,    -1,   122,
     284,    -1,   284,    -1,   306,    -1,   239,    -1,   302,    -1,
     148,    -1,   307,    -1,   115,   116,    -1,   288,    -1,   288,
     124,   289,    -1,   289,    -1,   289,   125,   290,    -1,   290,
      -1,   291,   126,   291,    -1,   291,   127,   291,    -1,   291,
     128,   291,    -1,   291,   129,   291,    -1,   291,   130,   291,
      -1,   291,   131,   291,    -1,   291,    71,   263,    -1,   291,
      70,    71,   263,    -1,   291,    -1,   292,   132,   291,    -1,
     292,   133,   291,    -1,   292,   304,    -1,   292,   305,    -1,
     292,    -1,   293,   134,   292,    -1,   293,   135,   292,    -1,
     293,    -1,   157,   294,    -1,   132,   294,    -1,   133,   294,
      -1,   294,    -1,   295,    -1,   296,    -1,   261,    -1,   286,
      -1,   283,    -1,   175,    -1,   115,   287,   116,    -1,    30,
     115,   287,   116,    -1,    34,   115,   287,   116,    -1,    26,
     115,   287,   114,   287,   116,    -1,    35,   115,   287,   116,
      -1,    16,   115,   283,   116,    -1,    31,   115,   287,   116,
      -1,    32,   115,   287,   116,    -1,    33,   115,   287,   116,
      -1,    33,   115,   116,    -1,   101,   115,   116,    -1,    97,
     115,   287,   116,    -1,    99,   115,   287,   116,    -1,   100,
     115,   287,   116,    -1,    98,   115,   287,   116,    -1,   102,
     115,   287,   116,    -1,   103,   115,   287,   116,    -1,   104,
     115,   287,   116,    -1,   105,   115,   287,   116,    -1,   106,
     115,   287,   116,    -1,   107,   115,   287,   116,    -1,   297,
      -1,   262,    -1,    69,   115,   287,   114,   287,   114,   287,
     116,    -1,    28,   115,   287,   114,   287,   116,    -1,    29,
     115,   287,   114,   287,   116,    -1,    40,   115,   287,   114,
     287,   116,    -1,    36,   115,   287,   116,    -1,    37,   115,
     287,   116,    -1,    38,   115,   287,   116,    -1,    39,   115,
     287,   116,    -1,   298,    -1,   299,    -1,   300,    -1,    84,
     115,   287,   116,    -1,    85,   115,   287,   114,   287,   116,
      -1,    85,   115,   287,   114,   287,   114,   287,   116,    -1,
      86,   115,   287,   116,    -1,    87,   115,   287,   116,    -1,
      88,   115,   287,   114,   287,   116,    -1,    89,   115,   287,
     114,   287,   116,    -1,    90,   115,   287,   114,   287,   116,
      -1,    91,   115,   287,   116,    -1,    92,   115,   184,   116,
      -1,    93,   115,   287,   114,   287,   116,    -1,    94,   115,
     287,   114,   287,   116,    -1,    95,   115,   287,   114,   287,
     114,   287,   116,    -1,    95,   115,   287,   114,   287,   114,
     287,   114,   287,   116,    -1,    23,   115,   287,   114,   287,
     116,    -1,    23,   115,   287,   114,   287,   114,   287,   116,
      -1,    76,   115,   287,   116,    -1,    77,   115,   287,   116,
      -1,    78,   115,   287,   116,    -1,    79,   115,   287,   116,
      -1,    80,   115,   287,   116,    -1,    81,   115,   287,   116,
      -1,    82,   115,   287,   116,    -1,    83,   115,   287,   116,
      -1,   110,   115,   116,    -1,   111,   115,   116,    -1,   112,
     115,   287,   116,    -1,   113,   115,   287,   116,    -1,   150,
      -1,   152,    -1,   303,    -1,   304,    -1,   305,    -1,   142,
      -1,   145,    -1,   139,    -1,   143,    -1,   146,    -1,   140,
      -1,   144,    -1,   147,    -1,   141,    -1,   149,    -1,   151,
      -1,   153,    -1,   117,   118,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   492,   492,   493,   498,   507,   521,   528,   548,   553,
     558,   566,   570,   571,   572,   576,   580,   584,   588,   592,
     596,   600,   604,   608,   612,   620,   628,   633,   640,   670,
     677,   695,   709,   714,   719,   729,   733,   743,   752,   761,
     779,   783,   825,   829,   833,   837,   841,   845,   849,   856,
     870,   876,   880,   888,   909,   930,   951,   972,   993,  1000,
    1009,  1018,  1034,  1062,  1084,  1107,  1152,  1176,  1193,  1202,
    1211,  1227,  1248,  1252,  1260,  1268,  1288,  1320,  1340,  1384,
    1401,  1434,  1449,  1453,  1461,  1476,  1485,  1505,  1535,  1555,
    1599,  1641,  1683,  1707,  1711,  1715,  1719,  1723,  1736,  1768,
    1803,  1808,  1815,  1842,  1877,  1913,  1922,  1941,  1945,  1952,
    1956,  1964,  1976,  2003,  2049,  2080,  2111,  2142,  2148,  2157,
    2162,  2169,  2193,  2216,  2224,  2228,  2236,  2241,  2248,  2262,
    2272,  2292,  2297,  2304,  2308,  2312,  2339,  2353,  2367,  2374,
    2381,  2391,  2411,  2425,  2432,  2437,  2442,  2447,  2453,  2461,
    2466,  2473,  2483,  2503,  2510,  2517,  2525,  2542,  2550,  2562,
    2576,  2589,  2603,  2610,  2619,  2636,  2641,  2648,  2660,  2680,
    2704,  2712,  2721,  2739,  2745,  2751,  2763,  2767,  2771,  2775,
    2779,  2791,  2795,  2806,  2864,  2878,  2890,  2927,  2932,  2944,
    2992,  3005,  3033,  3034,  3039,  3070,  3078,  3082,  3086,  3090,
    3094,  3098,  3102,  3110,  3149,  3199,  3216,  3226,  3241,  3248,
    3258,  3283,  3304,  3325,  3333,  3337,  3341,  3348,  3353,  3360,
    3399,  3433,  3461,  3468,  3478,  3495,  3502,  3510,  3515,  3526,
    3556,  3571,  3615,  3663,  3761,  3766,  3773,  3778,  3785,  3863,
    3868,  3875,  3883,  3893,  3921,  3925,  3933,  4000,  4127,  4180,
    4217,  4221,  4229,  4241,  4254,  4260,  4268,  4272,  4279,  4290,
    4294,  4298,  4308,  4312,  4316,  4320,  4324,  4328,  4338,  4346,
    4353,  4361,  4369,  4378,  4385,  4392,  4399,  4406,  4413,  4420,
    4425,  4430,  4439,  4446,  4453,  4466,  4479,  4486,  4493,  4500,
    4508,  4515,  4519,  4526,  4540,  4544,  4548,  4557,  4563,  4573,
    4581,  4589,  4596,  4603,  4610,  4617,  4632,  4639,  4646,  4653,
    4660,  4667,  4674,  4681,  4688,  4695,  4702,  4709,  4716,  4723,
    4730,  4737,  4741,  4745,  4752,  4759,  4766,  4773,  4780,  4787,
    4794,  4801,  4805,  4809,  4816,  4823,  4830,  4837,  4844,  4851,
    4858,  4865,  4872,  4879,  4886,  4893,  4900,  4907,  4918,  4925,
    4936,  4943,  4950,  4957,  4964,  4971,  4978,  4985,  4996,  5013,
    5031,  5049,  5074,  5080,  5100,  5104,  5108,  5115,  5119,  5123,
    5131,  5135,  5139,  5147,  5151,  5155,  5167,  5173,  5193,  5199
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SELECT", "FROM", "WHERE", "OPTIONAL",
  "DESCRIBE", "CONSTRUCT", "ASK", "DISTINCT", "REDUCED", "LIMIT", "UNION",
  "PREFIX", "BASE", "BOUND", "GRAPH", "NAMED", "FILTER", "OFFSET", "ORDER",
  "BY", "REGEX", "ASC", "DESC", "LANGMATCHES", "\"a\"", "\"strlang\"",
  "\"strdt\"", "\"str\"", "\"iri\"", "\"uri\"", "\"bnode\"", "\"lang\"",
  "\"datatype\"", "\"isUri\"", "\"isBlank\"", "\"isLiteral\"",
  "\"isNumeric\"", "\"sameTerm\"", "GROUP", "HAVING", "COUNT", "SUM",
  "AVG", "MIN", "MAX", "GROUP_CONCAT", "SAMPLE", "SEPARATOR", "DELETE",
  "INSERT", "WITH", "CLEAR", "CREATE", "SILENT", "DATA", "DROP", "LOAD",
  "INTO", "DEFAULT", "TO", "ADD", "MOVE", "COPY", "ALL", "COALESCE", "AS",
  "IF", "NOT", "IN", "BINDINGS", "UNDEF", "SERVICE", "MINUS", "YEAR",
  "MONTH", "DAY", "HOURS", "MINUTES", "SECONDS", "TIMEZONE", "TZ",
  "STRLEN", "SUBSTR", "UCASE", "LCASE", "STRSTARTS", "STRENDS", "CONTAINS",
  "ENCODE_FOR_URI", "CONCAT", "STRBEFORE", "STRAFTER", "REPLACE", "BIND",
  "ABS", "ROUND", "CEIL", "FLOOR", "RAND", "MD5", "SHA1", "SHA224",
  "SHA256", "SHA384", "SHA512", "EXPLAIN", "LET", "CURRENT_DATETIME",
  "NOW", "FROM_UNIXTIME", "TO_UNIXTIME", "','", "'('", "')'", "'['", "']'",
  "'{'", "'}'", "'?'", "'$'", "HATHAT", "SC_OR", "SC_AND", "EQ", "NEQ",
  "LT", "GT", "LE", "GE", "'+'", "'-'", "'*'", "'/'", "\":=\"",
  "\"string\"", "\"language tag\"", "\"double literal\"",
  "\"double positive literal\"", "\"double negative literal\"",
  "\"integer literal\"", "\"integer positive literal\"",
  "\"integer negative literal\"", "\"decimal literal\"",
  "\"decimal positive literal\"", "\"decimal negative literal\"",
  "\"boolean literal\"", "\"URI literal\"", "\"URI literal (\"",
  "\"QName literal\"", "\"QName literal (\"", "\"blank node literal\"",
  "\"identifier\"", "';'", "'.'", "'!'", "$accept", "Sparql", "Query",
  "ExplainOpt", "ReportFormat", "Update", "UpdateTailOpt",
  "UpdateOperation", "Prologue", "BaseDeclOpt", "PrefixDeclListOpt",
  "SelectQuery", "SubSelect", "SelectClause", "SelectExpressionList",
  "SelectExpressionListTail", "SelectTerm", "AggregateExpression",
  "DistinctOpt", "ExpressionOrStar", "CountAggregateExpression",
  "SumAggregateExpression", "AvgAggregateExpression",
  "MinAggregateExpression", "MaxAggregateExpression", "SeparatorOpt",
  "ExpressionList", "GroupConcatAggregateExpression",
  "SampleAggregateExpression", "ConstructQuery", "DescribeQuery",
  "VarOrIRIrefList", "AskQuery", "DatasetClause", "GraphRef",
  "DeleteQuery", "GraphTriples", "GraphTemplate", "ModifyTemplate",
  "ModifyTemplateList", "InsertQuery", "UpdateQuery", "GraphRefAll",
  "ClearQuery", "SilentOpt", "CreateQuery", "DropQuery", "IriRefList",
  "GraphOrDefault", "OldGraphRef", "LoadQuery", "AddQuery", "MoveQuery",
  "CopyQuery", "DatasetClauseList", "DatasetClauseListOpt",
  "DefaultGraphClause", "NamedGraphClause", "SourceSelector",
  "WhereClause", "WhereClauseOpt", "SolutionModifier",
  "GroupConditionList", "AsVarOpt", "GroupCondition", "GroupClauseOpt",
  "HavingCondition", "HavingConditionList", "HavingClauseOpt",
  "LimitOffsetClausesOpt", "OrderClauseOpt", "OrderConditionList",
  "OrderCondition", "LimitClause", "OffsetClause", "BindingsClauseOpt",
  "VarList", "BindingsRowListOpt", "BindingsRowList", "BindingsRow",
  "BindingValueList", "RDFLiteral", "BindingValue", "GroupGraphPattern",
  "GroupGraphPatternSub", "TriplesBlockOpt", "GraphPatternListOpt",
  "GraphPatternList", "GraphPatternListFilter", "DotOptional",
  "TriplesBlock", "GraphPatternNotTriples", "OptionalGraphPattern",
  "GraphGraphPattern", "ServiceGraphPattern", "MinusGraphPattern",
  "GroupOrUnionGraphPattern", "GroupOrUnionGraphPatternList",
  "LetGraphPattern", "BindGraphPattern", "Filter", "Constraint",
  "ParamsOpt", "FunctionCall", "CoalesceExpression", "ArgList",
  "ArgListNoBraces", "ConstructTemplate", "ConstructTriplesOpt",
  "ConstructTriples", "TriplesSameSubject", "PropertyListNotEmpty",
  "PropertyListTailOpt", "PropertyList", "ObjectList", "ObjectTail",
  "Object", "Verb", "TriplesNode", "BlankNodePropertyList", "Collection",
  "GraphNodeListNotEmpty", "GraphNode", "VarOrTerm", "VarOrIRIref", "Var",
  "VarName", "VarOrBadVarName", "GraphTerm", "Expression",
  "ConditionalOrExpression", "ConditionalAndExpression",
  "RelationalExpression", "AdditiveExpression", "MultiplicativeExpression",
  "UnaryExpression", "PrimaryExpression", "BrackettedExpression",
  "BuiltInCall", "StringExpression", "RegexExpression",
  "DatetimeBuiltinAccessors", "DatetimeExtensions", "IRIrefBrace",
  "NumericLiteral", "NumericLiteralUnsigned", "NumericLiteralPositive",
  "NumericLiteralNegative", "IRIref", "BlankNode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    44,    40,    41,    91,    93,   123,
     125,    63,    36,   369,   370,   371,   372,   373,   374,   375,
     376,   377,    43,    45,    42,    47,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    59,    46,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   158,   159,   159,   160,   161,   161,   162,   162,   162,
     162,   163,   164,   164,   164,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   166,   167,   167,   168,   168,
     169,   170,   171,   171,   171,   172,   172,   173,   173,   173,
     174,   174,   175,   175,   175,   175,   175,   175,   175,   176,
     176,   177,   177,   178,   179,   180,   181,   182,   183,   183,
     184,   184,   185,   186,   187,   187,   188,   188,   189,   189,
     189,   190,   191,   191,   192,   193,   193,   193,   193,   194,
     194,   195,   196,   196,   197,   197,   198,   198,   198,   199,
     199,   199,   199,   200,   200,   200,   200,   200,   201,   201,
     202,   202,   203,   203,   204,   205,   205,   206,   206,   207,
     207,   207,   208,   208,   209,   210,   211,   212,   212,   213,
     213,   214,   215,   216,   217,   217,   218,   218,   219,   220,
     220,   221,   221,   222,   222,   222,   222,   223,   223,   224,
     225,   225,   226,   226,   227,   227,   227,   227,   227,   228,
     228,   229,   229,   230,   230,   230,   230,   230,   230,   231,
     232,   233,   233,   234,   234,   235,   235,   236,   236,   237,
     237,   238,   238,   239,   239,   239,   240,   240,   240,   240,
     240,   241,   241,   242,   243,   243,   244,   244,   244,   245,
     246,   246,   247,   247,   248,   248,   249,   249,   249,   249,
     249,   249,   249,   250,   251,   252,   253,   254,   254,   255,
     255,   256,   257,   258,   259,   259,   259,   260,   260,   261,
     261,   262,   263,   264,   264,   264,   265,   266,   266,   267,
     267,   268,   268,   269,   270,   270,   271,   271,   272,   273,
     273,   274,   275,   275,   276,   276,   277,   278,   279,   279,
     280,   280,   281,   281,   282,   282,   283,   283,   284,   285,
     285,   285,   286,   286,   286,   286,   286,   286,   287,   288,
     288,   289,   289,   290,   290,   290,   290,   290,   290,   290,
     290,   290,   291,   291,   291,   291,   291,   292,   292,   292,
     293,   293,   293,   293,   294,   294,   294,   294,   294,   294,
     295,   296,   296,   296,   296,   296,   296,   296,   296,   296,
     296,   296,   296,   296,   296,   296,   296,   296,   296,   296,
     296,   296,   296,   296,   296,   296,   296,   296,   296,   296,
     296,   296,   296,   296,   297,   297,   297,   297,   297,   297,
     297,   297,   297,   297,   297,   297,   297,   297,   298,   298,
     299,   299,   299,   299,   299,   299,   299,   299,   300,   300,
     300,   300,   301,   301,   302,   302,   302,   303,   303,   303,
     304,   304,   304,   305,   305,   305,   306,   306,   307,   307
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     4,     1,     0,     1,     1,     1,
       1,     3,     2,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     0,     4,     0,
       4,     3,     3,     3,     2,     1,     1,     2,     3,     1,
       1,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     5,     5,     5,     5,     5,     4,     0,
       3,     1,     6,     5,     5,     7,     5,     5,     2,     3,
       1,     3,     2,     2,     2,     3,     5,     5,     3,     1,
       5,     5,     1,     1,     2,     1,     3,     5,     5,    11,
       7,     7,     7,     1,     1,     1,     1,     2,     3,     1,
       1,     0,     3,     3,     3,     2,     1,     1,     1,     1,
       1,     1,     3,     5,     5,     5,     5,     2,     1,     1,
       0,     1,     2,     1,     2,     1,     1,     0,     4,     2,
       1,     2,     0,     1,     1,     4,     1,     3,     0,     1,
       2,     1,     2,     0,     2,     2,     1,     1,     0,     3,
       0,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       2,     5,     0,     2,     1,     1,     0,     2,     1,     3,
       2,     2,     1,     1,     2,     3,     1,     1,     1,     1,
       1,     3,     3,     2,     1,     0,     2,     1,     0,     3,
       1,     1,     1,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     4,     2,     3,     1,     3,
       1,     6,     6,     2,     1,     1,     1,     1,     0,     6,
       3,     2,     3,     3,     1,     0,     3,     1,     0,     3,
       1,     2,     2,     3,     2,     0,     1,     0,     2,     2,
       0,     1,     1,     1,     1,     1,     3,     3,     2,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     2,     1,     3,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     3,     3,     2,     2,     1,     3,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     4,     6,     4,     4,     4,     4,     4,     3,
       3,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     1,     1,     8,     6,     6,     6,     4,     4,     4,
       4,     1,     1,     1,     4,     6,     8,     4,     4,     6,
       6,     6,     4,     4,     6,     6,     8,    10,     6,     8,
       4,     4,     4,     4,     4,     4,     4,     4,     3,     3,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      27,     0,     0,     2,     3,     6,    29,    26,     1,     0,
       0,     0,   101,   101,   101,   101,   101,   101,   101,     5,
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,     0,     0,     0,     0,   118,   127,     0,
       0,   127,     0,   100,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   120,   120,   162,     7,   120,     8,     9,
      10,    27,    11,     0,     0,   376,   377,    72,    73,   121,
     123,   185,    78,     0,     0,     0,     0,     0,     0,   173,
     369,   372,   375,   367,   370,   373,   368,   371,   374,   265,
     378,    83,    85,     0,   263,    82,   230,   237,   245,   244,
       0,   252,   253,   264,   364,   365,   366,   262,   266,     0,
     117,   126,    75,   125,     0,     0,    86,     0,     0,     0,
      95,    94,    96,    93,    98,     0,   102,   103,   104,   106,
       0,   107,   108,     0,     0,     0,     0,     0,     0,    36,
      34,    35,    39,    40,   120,   120,    70,   254,   255,   228,
     119,     0,   120,     0,     0,     4,     0,    12,     0,     0,
     122,     0,     0,     0,   188,   184,   195,     0,     0,    79,
       0,   267,   251,     0,   249,   250,   243,   379,     0,     0,
     242,   258,   256,   257,     0,   174,     0,    84,   228,   236,
     232,   231,   124,     0,   127,     0,     0,     0,    97,    74,
       0,   105,     0,     0,     0,    32,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   362,   363,     0,   299,    42,    43,    44,    45,    46,
      47,    48,   296,   322,   298,   297,     0,   268,   270,   272,
     281,   286,   289,   293,   294,   295,   321,   331,   332,   333,
     225,   262,     0,    37,   127,     0,   127,    68,     0,   227,
       0,     0,    71,     0,   164,   138,    28,   181,   138,   182,
       0,     0,     0,   101,     0,     0,     0,   208,   183,   187,
     193,   190,   197,   199,   200,   198,   196,   201,   202,   191,
     185,     0,    77,     0,   247,   248,   246,   235,   240,   241,
     175,    76,   229,    88,    87,     0,     0,     0,   111,   110,
     109,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,    50,    50,    50,    50,    50,    50,   225,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   291,   292,   290,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   284,   285,     0,     0,     0,   224,    50,
      38,   138,    69,   138,   226,     0,   138,   166,   163,     0,
      30,   143,    31,   203,     0,     0,   213,   216,   214,   215,
       0,     0,   206,     0,     0,     0,   186,   192,   185,   194,
       0,     0,   237,   233,     0,   238,   127,     0,   127,     0,
       0,     0,     0,     0,     0,     0,     0,   309,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    61,     0,     0,     0,     0,     0,     0,
       0,   310,     0,     0,     0,     0,     0,     0,   358,   359,
       0,     0,   300,     0,     0,   261,     0,   269,   271,     0,
     279,   273,   274,   275,   276,   277,   278,   282,   283,   287,
     288,     0,   220,   225,    67,    66,     0,    64,     0,     0,
     165,   168,     0,     0,   150,   204,     0,     0,     0,   210,
     207,   189,     0,    81,   234,   239,     0,    90,    92,    91,
     305,     0,     0,     0,     0,   301,   306,   307,   308,   302,
     304,   327,   328,   329,   330,     0,    52,     0,    51,     0,
       0,     0,     0,    59,     0,   222,     0,   350,   351,   352,
     353,   354,   355,   356,   357,   334,     0,   337,   338,     0,
       0,     0,   342,     0,   343,     0,     0,     0,   311,   314,
     312,   313,   315,   316,   317,   318,   319,   320,   360,   361,
     259,   260,    41,   280,   223,   218,   138,   180,   170,   179,
       0,   177,   172,   178,   176,   161,   167,     0,   137,   130,
     134,   136,   133,   141,   142,   139,     0,   148,   205,     0,
       0,     0,    80,     0,     0,     0,     0,     0,     0,    53,
      54,    55,    56,    57,     0,     0,    63,     0,     0,     0,
       0,     0,    60,     0,     0,     0,   217,     0,    65,   169,
     171,   132,   129,   140,     0,     0,     0,   128,   146,   147,
       0,     0,   209,     0,     0,   348,   303,   324,   325,   326,
       0,    62,     0,     0,   335,   339,   340,   341,   344,   345,
       0,   219,     0,     0,     0,     0,   149,   152,   155,   156,
     157,   158,   159,   160,   144,   145,   212,   211,   127,     0,
       0,     0,     0,     0,   131,   135,   153,   154,   151,    89,
     349,    58,   323,   336,     0,   346,     0,   347
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    20,    55,     4,    62,    21,     5,     6,
      32,    56,   161,    57,   140,   141,   142,   274,   507,   617,
     275,   276,   277,   278,   279,   705,   532,   280,   281,    58,
      59,   145,    60,    37,   123,    22,   168,    91,    92,    93,
      23,    24,   124,    25,    44,    26,    27,   130,   133,   361,
      28,    29,    30,    31,   150,   151,    67,    68,    69,   111,
     112,   460,   678,   753,   679,   461,   683,   684,   584,   727,
     687,   756,   757,   728,   729,   155,   313,   579,   580,   581,
     670,    94,   672,   113,   163,   164,   328,   329,   330,   478,
     165,   331,   332,   333,   334,   335,   336,   590,   337,   338,
     339,   685,   717,   282,   283,   389,   447,   152,   308,    95,
      96,   189,   483,   190,   347,   485,   348,   179,    97,    98,
      99,   173,   349,   100,   180,   284,   182,   556,   285,   448,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   103,   104,   105,   106,   301,   108
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -502
static const yytype_int16 yypact[] =
{
      43,   -63,    96,  -502,  -502,   813,  -502,  -502,  -502,    74,
      51,   -56,    19,    78,    78,    78,    78,    78,    78,  -502,
     339,   -17,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,  -502,   134,    13,    68,    81,  1959,  -502,    48,   103,
    1959,    48,   194,  -502,   178,    37,   178,   -31,    40,    40,
      40,    95,   185,    56,   210,   163,  -502,   210,  -502,  -502,
    -502,   127,  -502,    88,   -23,  -502,  -502,  -502,  -502,  -502,
    -502,   353,  -502,  2002,   135,   944,    76,    94,    94,    85,
    -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,  -502,  -502,   538,  -502,  -502,    98,   128,  -502,  -502,
     128,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,    68,
    -502,  -502,  -502,  -502,  2002,   591,  -502,   132,     0,    62,
    -502,  -502,  -502,  -502,  -502,   113,  -502,  -502,  -502,    25,
      39,  -502,  -502,   216,   218,   223,   119,   119,  1569,  -502,
    -502,   160,  -502,  -502,   210,    70,  -502,  -502,  -502,  2076,
     210,   282,   210,    35,   177,  -502,    35,  -502,   408,   142,
    -502,   173,    35,   181,   241,  -502,   149,   165,   192,  -502,
     198,  -502,  -502,  2041,  -502,  -502,  -502,  -502,   204,  2076,
    -502,  -502,  -502,  -502,   -23,  -502,    35,  -502,  2076,  -502,
    -502,  -502,  -502,   206,    35,  1959,   214,  1959,  -502,  -502,
      12,  -502,    40,    40,    40,  -502,  -502,   220,   238,   239,
     240,   246,   247,   249,   253,   255,   257,   258,   267,   268,
     270,   271,   272,   273,   274,   275,   287,   288,   290,   291,
     293,   295,   298,   299,   300,   301,   302,   303,   307,   321,
     323,   329,   334,   338,   342,   343,   349,   350,   354,   361,
     362,   363,   364,   365,   368,   369,   370,   371,   372,   373,
     374,   388,   390,   393,   394,   396,   397,  1155,   395,  1707,
    1707,  -502,  -502,  1707,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,  -502,   449,   402,   415,  -502,
     269,   234,   137,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    1569,   406,   188,  -502,    35,   135,    35,  -502,   421,  -502,
     424,    35,  -502,   -27,  -502,   504,  -502,  -502,   504,  -502,
      68,   135,  1845,    78,    68,   434,   437,   534,   241,  -502,
     398,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    2076,   438,  -502,  2076,  -502,  -502,  -502,   401,   439,  -502,
    -502,  -502,  -502,  -502,  -502,   990,  2002,  1869,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,   177,  1569,  1569,  1569,  1569,
    1569,  1569,  1569,  1293,  1569,  1569,  1569,  1569,  1569,  1569,
    1569,   548,   548,   548,   548,   548,   548,   548,  1569,  -502,
    1569,  1569,  1569,  1569,  1569,  1569,  1569,  1569,  1569,  1569,
    1569,  1569,  1569,  1569,  1569,  1569,  1569,  1569,  1569,  1569,
    1569,  1569,  1569,  1569,  1569,   443,  1569,  1569,  1569,  1569,
    1569,  1569,   444,   445,  1569,  1569,   447,  -502,  -502,  -502,
     -52,  1569,  1569,   493,   293,  1569,  1569,  1569,  1569,  1569,
    1569,  1569,  1569,  -502,  -502,  1569,  1569,    16,  -502,   548,
    -502,   504,  -502,   504,  -502,  2076,   504,   450,  -502,   545,
    -502,   527,  -502,  -502,    68,  1569,  -502,  -502,  -502,  -502,
     406,   135,  -502,  1569,   177,    68,  -502,  -502,  2076,  -502,
    2076,   451,   128,  -502,  2076,  -502,    93,   452,    35,   457,
     460,   481,   501,   502,   491,   497,   503,  -502,   506,   507,
     508,   509,   510,   511,   512,   515,  -502,  1431,  1569,  1569,
    1569,  1569,  1569,  1569,    52,   516,   517,   518,   519,   520,
     521,   523,   524,   525,   528,   529,   531,   541,   540,   549,
     550,   546,   104,  -502,   551,   552,   554,   553,   555,   556,
     557,  -502,   558,   560,   572,   574,   577,   578,  -502,  -502,
     579,   580,  -502,    94,    94,  -502,   581,   415,  -502,   293,
    -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,  1569,  -502,  1569,  -502,  -502,   582,  -502,   631,   583,
     450,  -502,   880,  1845,   596,  -502,    68,   563,   496,  -502,
     632,  -502,   585,  -502,  -502,  -502,   588,  -502,  -502,  -502,
    -502,  1569,  1569,  1569,  1569,  -502,  -502,  -502,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,  1569,  -502,   584,  -502,   593,
     594,   599,   600,   -33,   601,  -502,  1569,  -502,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,  -502,  1569,  -502,  -502,  1569,
    1569,  1569,  -502,  1569,  -502,  1569,  1569,  1569,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,   -30,   504,  -502,  -502,  -502,
     742,  -502,  -502,  -502,  -502,  -502,  -502,  1569,   880,  -502,
    -502,  -502,  -502,  -502,  1845,  -502,   648,    77,  -502,   177,
    1569,    68,  -502,  1959,   112,   602,   603,   604,   605,  -502,
    -502,  -502,  -502,  -502,   672,   607,  -502,   612,   116,   625,
     627,   629,  -502,   630,   633,   634,  -502,   635,  -502,  -502,
    -502,   682,  -502,  -502,   499,   610,   611,  -502,   678,   743,
     638,   640,  -502,  1924,  1569,  -502,  -502,  -502,  -502,  -502,
     636,  -502,  1569,  1569,  -502,  -502,  -502,  -502,  -502,  -502,
    1569,  -502,   177,   642,   644,   644,   499,  -502,  -502,  -502,
    -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,    35,   645,
     626,   649,   650,   122,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,  -502,  -502,  -502,  1569,  -502,   651,  -502
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -502,  -502,  -502,  -502,  -502,   703,  -502,  -502,   720,  -502,
    -502,  -502,  -502,   712,   184,  -502,  -126,  -502,   -55,  -502,
    -502,  -502,  -502,  -502,  -502,  -502,   277,  -502,  -502,  -502,
    -502,  -502,  -502,    21,   -18,  -502,  -101,  -502,   -91,   -37,
    -502,  -502,   738,  -502,    20,  -502,  -502,  -502,    -1,  -502,
    -502,  -502,  -502,  -502,   335,   150,  -502,  -502,   721,  -106,
     -41,  -307,  -502,  -502,   108,  -502,   106,  -502,  -502,  -502,
    -502,  -502,    31,    65,    63,  -502,  -502,  -502,  -502,   213,
    -502,  -501,   125,   -24,  -502,  -319,  -502,   468,  -502,  -502,
     -68,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,  -502,
    -502,   492,  -502,  -315,  -502,  -416,  -374,  -502,   628,  -137,
     -43,   -10,  -502,   331,   333,  -502,  -502,  -502,   -59,  -502,
    -502,  -502,   -49,   -58,   -29,    36,   -72,  -502,    64,   432,
    -502,   387,   389,    -8,   -94,  -502,  -206,  -300,  -313,  -502,
    -502,  -502,  -502,  -502,  -487,  -502,   564,   568,   -32,  -502
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -113
static const yytype_int16 yytable[] =
{
     116,    70,   187,   115,   107,   169,   183,   467,   107,   469,
      72,   462,   309,   193,   514,   303,   172,   175,   560,   -99,
     148,   479,   468,   146,   187,  -112,   174,   127,   166,   125,
     166,    64,    70,    45,    46,    47,    48,    49,    50,   107,
     109,   107,   148,   107,   148,   170,   169,   312,   134,   135,
     315,   309,    33,   109,   125,    33,   318,   196,     1,   110,
      33,   107,   110,   427,   428,   148,   178,   429,   148,   553,
     554,   166,   101,   358,    33,    43,   101,   671,    33,    34,
     351,   643,   107,   107,   571,   192,     7,   143,   147,   725,
     191,   673,   457,    42,    77,    78,     8,   726,   109,   200,
     102,   131,   181,   176,   102,   136,   137,   101,    39,   101,
     147,   101,   147,   148,   172,   175,   307,   107,   129,   197,
     172,   175,   704,   198,   345,   716,    65,   -13,    66,   101,
     571,    35,   572,   147,    43,   102,   147,   102,    61,   102,
     327,   107,     1,   663,   574,   596,   575,   107,    63,   577,
     101,   101,   350,   354,    71,   176,   107,   102,   355,   591,
     357,   359,    65,   107,    66,   107,   571,    71,   625,   671,
      40,   110,   143,   143,   -99,   149,   450,   143,   102,   102,
    -112,   147,   360,   673,   305,   101,   126,    71,   201,   132,
     314,    77,    78,    36,   177,   119,   120,    77,    78,   665,
      73,   362,   363,   364,   153,   456,   481,   156,   184,   101,
     138,   199,    71,   102,    33,   101,    77,    78,   643,    65,
     644,    66,   114,   185,   101,    65,   734,    66,   735,   139,
     743,   101,   744,   101,   138,   154,   784,   102,   785,   121,
      77,    78,   159,   102,   122,   117,   118,   320,   181,    77,
      78,   195,   102,   139,   188,   487,    77,    78,   321,   102,
     322,   102,   199,   451,   187,   453,   187,   680,   467,   682,
     469,   445,   446,   148,   302,   138,   452,    65,   202,    66,
     203,    77,    78,   468,    65,   204,    66,   310,   169,   148,
     470,   316,   464,   317,   304,   306,   463,   166,    77,    78,
     472,   319,   311,   138,   327,   340,    77,    78,   107,    77,
      78,   107,   342,   166,   341,   323,   324,   343,   576,   144,
     205,   206,   346,   107,   107,   107,   353,   508,   509,   510,
     511,   512,   513,   356,    65,   365,    66,   325,   143,   433,
     434,   147,    51,   471,    38,    41,    52,    53,    54,   458,
     326,   569,   570,   366,   367,   368,    51,   147,   555,   718,
      71,   369,   370,   680,   371,   682,   441,   442,   372,   467,
     373,   469,   374,   375,    81,    82,   101,    84,    85,   101,
      87,    88,   376,   377,   468,   378,   379,   380,   381,   382,
     383,   101,   101,   101,   573,   435,   436,   437,   438,   439,
     440,   489,   384,   385,   102,   386,   387,   102,   388,   758,
     390,   761,   592,   391,   392,   393,   394,   395,   396,   102,
     102,   102,   397,   107,   760,   172,   175,   561,   562,   563,
     564,   565,   566,   567,   568,   166,   398,   166,   399,   148,
     585,   758,   586,   761,   400,   597,   107,   599,   107,   401,
     148,   589,   107,   402,   776,   777,   760,   403,   404,     9,
      10,    11,    12,    13,   405,   406,    14,    15,    75,   407,
      76,    16,    17,    18,    77,    78,   408,   409,   410,   411,
     412,   660,   661,   413,   414,   415,   416,   417,   418,   419,
      79,   101,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    65,   420,    66,   421,    90,   147,   422,   423,
     588,   424,   425,   177,   101,   207,   101,   430,   147,   102,
     101,   449,   208,   754,   755,   209,   431,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     432,   454,   102,   455,   102,   459,   674,   475,   102,   473,
     470,   470,   474,   484,   477,    74,   482,   480,   506,   541,
     548,   549,   688,   552,   559,   578,   230,   582,   231,   583,
     286,   593,   598,   600,   601,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   602,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   605,    74,   263,
     264,   265,   266,   606,   465,   603,   604,   686,   681,   607,
      77,    78,   608,   609,   610,   611,   612,   613,   614,   615,
     626,   689,   690,   627,   628,   629,   630,   631,   674,   632,
     633,   634,   187,   636,   635,   691,   470,   637,    65,   271,
      66,   272,   470,    75,   639,    76,   733,   638,   186,    77,
      78,   107,   642,   640,   641,   645,   646,   732,   647,   648,
     724,   649,   650,   651,   652,    79,   653,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    65,   654,    66,
     655,    90,   470,   656,   657,   658,   659,   662,   726,   426,
     699,   107,   666,   675,   667,   692,    75,   693,    76,   700,
     701,   194,    77,    78,   681,   702,   703,   706,   736,   737,
     738,   739,   740,   741,   470,   730,   742,   779,    79,   101,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      65,   745,    66,   746,    90,   747,   748,   668,   750,   749,
     752,   751,   762,   763,   766,   725,   767,   102,   775,   465,
     759,   780,   770,   781,   157,   782,   783,   787,    79,   101,
      80,    81,    82,    83,    84,    85,    86,    87,    88,   669,
      65,   158,    66,   162,   128,   160,   722,   778,   774,   623,
     723,   764,   759,   676,   765,   720,   476,   102,   490,   491,
     492,   493,   494,   495,   496,   498,   499,   500,   501,   502,
     503,   504,   505,   594,   466,   667,   352,   595,   557,     0,
       0,   558,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   533,
     534,   535,   536,   537,   538,   539,   540,     0,   542,   543,
     544,   545,   546,   547,     0,   443,   550,   551,   719,   444,
       0,     0,     0,     0,     9,    10,    11,    12,    13,     0,
       0,    14,    15,     0,     0,     0,    16,    17,    18,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
     669,    65,     0,    66,     0,     0,   207,   426,     0,     0,
       0,     0,     0,   208,     0,   587,   209,     0,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    19,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   618,
     619,   620,   621,   622,   533,   624,     0,   230,     0,   231,
       0,     0,     0,     0,     0,     0,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,     0,
     263,   264,   265,   266,     0,   677,     0,     0,     0,     0,
       0,    77,    78,   664,     0,     0,     0,    74,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    65,
     271,    66,   272,   694,   695,   696,   697,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   698,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   707,    75,
     171,    76,     0,     0,     0,    77,    78,     0,   708,     0,
       0,   709,   710,   711,     0,   712,     0,   713,   714,   715,
       0,    79,     0,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    65,     0,    66,     0,    90,     0,     0,
       0,     0,     0,     0,     0,    75,     0,    76,     0,   721,
     486,    77,    78,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   731,     0,     0,     0,     0,    79,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    65,
       0,    66,     0,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   769,     0,     0,     0,
       0,   207,     0,     0,   771,   772,     0,     0,   208,     0,
       0,   209,   773,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,   229,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   786,     0,     0,     0,
       0,     0,   230,     0,   231,     0,     0,     0,     0,     0,
       0,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,   263,   264,   265,   266,     0,
     267,   171,   268,     0,     0,     0,    77,    78,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   269,   270,     0,
       0,     0,    79,     0,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    65,   271,    66,   272,    90,   207,
       0,     0,   273,     0,     0,     0,   208,     0,     0,   209,
       0,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,   229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     230,     0,   231,     0,     0,     0,     0,     0,     0,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,   263,   264,   265,   266,     0,   267,   497,
     268,     0,     0,     0,    77,    78,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   269,   270,     0,     0,     0,
      79,     0,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    65,   271,    66,   272,    90,   207,     0,     0,
     273,     0,     0,     0,   208,     0,     0,   209,     0,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
     229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,     0,
     231,     0,     0,     0,     0,     0,     0,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,   263,   264,   265,   266,     0,   267,     0,   268,     0,
       0,     0,    77,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   269,   270,   616,     0,     0,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      65,   271,    66,   272,    90,   207,     0,     0,   273,     0,
       0,     0,   208,     0,     0,   209,     0,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,   229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   230,     0,   231,     0,
       0,     0,     0,     0,     0,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,   263,
     264,   265,   266,     0,   267,     0,   268,     0,     0,     0,
      77,    78,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   269,   270,     0,     0,     0,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    65,   271,
      66,   272,    90,   207,     0,     0,   273,     0,     0,     0,
     208,     0,     0,   209,     0,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,   229,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,     0,   231,     0,     0,     0,
       0,     0,     0,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,   263,   264,   265,
     266,     0,   267,     0,   268,     0,     0,     0,    77,    78,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    65,   271,    66,   272,
      90,   207,     0,     0,     0,     0,     0,     0,   208,     0,
       0,   209,     0,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    74,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   230,     0,   231,     0,     0,     0,     0,     0,
       0,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    74,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,   263,   264,   265,   266,     0,
     465,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    74,     0,     0,     0,
       0,     0,     0,     0,    75,     0,    76,     0,     0,   488,
      77,    78,     0,     0,    65,   271,    66,   272,     0,     0,
       0,     0,     0,     0,     0,     0,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    65,   167,
      66,     0,    90,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    75,
       0,    76,     0,     0,   768,    77,    78,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    79,     0,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    65,    75,    66,    76,    90,     0,     0,
      77,    78,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    65,     0,
      66,     0,    90,     0,     0,     0,     0,    75,     0,    76,
       0,     0,     0,    77,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    65,     0,    66,     0,    90,    75,   344,    76,     0,
       0,     0,    77,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      65,    75,    66,    76,    90,     0,     0,    77,    78,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    79,     0,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    65,     0,    66,     0,    90
};

static const yytype_int16 yycheck[] =
{
      41,    33,    93,    40,    36,    73,    78,   322,    40,   322,
      34,   318,   149,   114,   388,   141,    75,    75,   434,     0,
      52,   340,   322,    52,   115,     0,    75,    45,    71,    17,
      73,    18,    64,    13,    14,    15,    16,    17,    18,    71,
       5,    73,    74,    75,    76,    74,   114,   153,    49,    50,
     156,   188,     4,     5,    17,     4,   162,    57,    15,    38,
       4,    93,    41,   269,   270,    97,    76,   273,   100,   121,
     122,   114,    36,    61,     4,    56,    40,   578,     4,     5,
     186,   114,   114,   115,   114,   109,   149,    51,    52,    12,
     100,   578,   119,   149,   121,   122,     0,    20,     5,    60,
      36,    61,   154,    27,    40,    10,    11,    71,    57,    73,
      74,    75,    76,   145,   173,   173,   145,   149,   149,   119,
     179,   179,   155,    61,   173,   155,   149,     0,   151,    93,
     114,    57,   116,    97,    56,    71,   100,    73,   155,    75,
     164,   173,    15,   559,   451,    52,   453,   179,    14,   456,
     114,   115,   184,   194,   119,    27,   188,    93,   195,   478,
     197,   149,   149,   195,   151,   197,   114,   119,   116,   670,
     119,   150,   136,   137,   155,   119,   302,   141,   114,   115,
     155,   145,   200,   670,   114,   149,   149,   119,   149,   149,
     154,   121,   122,   119,   118,    17,    18,   121,   122,   573,
     119,   202,   203,   204,    54,   311,   343,    57,   123,   173,
     115,   149,   119,   149,     4,   179,   121,   122,   114,   149,
     116,   151,   119,   138,   188,   149,   114,   151,   116,   134,
     114,   195,   116,   197,   115,    72,   114,   173,   116,    61,
     121,   122,   154,   179,    66,    51,    52,     6,   154,   121,
     122,   119,   188,   134,   156,   356,   121,   122,    17,   195,
      19,   197,   149,   304,   355,   306,   357,   582,   583,   582,
     583,   134,   135,   305,   114,   115,   305,   149,    62,   151,
      62,   121,   122,   583,   149,    62,   151,     5,   356,   321,
     322,   149,   321,   120,   144,   145,   320,   340,   121,   122,
     324,   120,   152,   115,   328,   156,   121,   122,   340,   121,
     122,   343,   120,   356,   149,    74,    75,   119,   455,   134,
     136,   137,   118,   355,   356,   357,   120,   382,   383,   384,
     385,   386,   387,   119,   149,   115,   151,    96,   302,    70,
      71,   305,     3,   323,     9,    10,     7,     8,     9,   313,
     109,   445,   446,   115,   115,   115,     3,   321,   430,   666,
     119,   115,   115,   678,   115,   678,   132,   133,   115,   684,
     115,   684,   115,   115,   140,   141,   340,   143,   144,   343,
     146,   147,   115,   115,   684,   115,   115,   115,   115,   115,
     115,   355,   356,   357,   449,   126,   127,   128,   129,   130,
     131,   365,   115,   115,   340,   115,   115,   343,   115,   724,
     115,   724,   480,   115,   115,   115,   115,   115,   115,   355,
     356,   357,   115,   455,   724,   484,   484,   435,   436,   437,
     438,   439,   440,   441,   442,   478,   115,   480,   115,   471,
     464,   756,   471,   756,   115,   486,   478,   488,   480,   115,
     482,   475,   484,   115,   754,   755,   756,   115,   115,    51,
      52,    53,    54,    55,   115,   115,    58,    59,   115,   115,
     117,    63,    64,    65,   121,   122,   115,   115,   115,   115,
     115,   553,   554,   115,   115,   115,   115,   115,   115,   115,
     137,   455,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   115,   151,   115,   153,   471,   115,   115,
     474,   115,   115,   118,   478,    16,   480,    68,   482,   455,
     484,   115,    23,    24,    25,    26,   124,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     125,   120,   478,   119,   480,    41,   578,    13,   484,   115,
     582,   583,   115,   114,   156,    17,   155,   119,    10,   116,
     116,   116,   586,   116,    71,   115,    67,    22,    69,    42,
     138,   120,   120,   116,   114,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,   114,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   116,    17,   110,
     111,   112,   113,   116,   115,   114,   114,    21,   582,   116,
     121,   122,   116,   116,   116,   116,   116,   116,   116,   114,
     114,    68,   136,   116,   116,   116,   116,   116,   670,   116,
     116,   116,   733,   114,   116,    13,   678,   116,   149,   150,
     151,   152,   684,   115,   114,   117,   693,   116,   120,   121,
     122,   693,   116,   114,   114,   114,   114,   691,   114,   116,
      22,   116,   116,   116,   116,   137,   116,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   116,   151,
     116,   153,   724,   116,   116,   116,   116,   116,    20,   267,
     116,   733,   120,   120,    73,   120,   115,   119,   117,   116,
     116,   120,   121,   122,   678,   116,   116,   116,   116,   116,
     116,   116,    50,   116,   756,   689,   114,   768,   137,   693,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   116,   151,   116,   153,   116,   116,   116,   114,   116,
      68,   116,   142,   142,   116,    12,   116,   693,   116,   115,
     724,   116,   126,   137,    61,   116,   116,   116,   137,   733,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    61,   151,    71,    46,    64,   678,   756,   752,   512,
     684,   728,   756,   580,   729,   670,   328,   733,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   482,   322,    73,   188,   484,   431,    -1,
      -1,   432,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,    -1,   291,   424,   425,   116,   291,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    -1,    -1,    -1,    63,    64,    65,   137,
      -1,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,    -1,    16,   465,    -1,    -1,
      -1,    -1,    -1,    23,    -1,   473,    26,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,    -1,    67,    -1,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    -1,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,    -1,
     110,   111,   112,   113,    -1,   115,    -1,    -1,    -1,    -1,
      -1,   121,   122,   571,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
     150,   151,   152,   601,   602,   603,   604,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   615,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   626,   115,
     116,   117,    -1,    -1,    -1,   121,   122,    -1,   636,    -1,
      -1,   639,   640,   641,    -1,   643,    -1,   645,   646,   647,
      -1,   137,    -1,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   115,    -1,   117,    -1,   677,
     120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   690,    -1,    -1,    -1,    -1,   137,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   734,    -1,    -1,    -1,
      -1,    16,    -1,    -1,   742,   743,    -1,    -1,    23,    -1,
      -1,    26,   750,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   784,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    -1,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    -1,    -1,   110,   111,   112,   113,    -1,
     115,   116,   117,    -1,    -1,    -1,   121,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,   133,    -1,
      -1,    -1,   137,    -1,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,    16,
      -1,    -1,   157,    -1,    -1,    -1,    23,    -1,    -1,    26,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    69,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    -1,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    -1,    -1,   110,   111,   112,   113,    -1,   115,   116,
     117,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,   133,    -1,    -1,    -1,
     137,    -1,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,    16,    -1,    -1,
     157,    -1,    -1,    -1,    23,    -1,    -1,    26,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    -1,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    -1,
      -1,   110,   111,   112,   113,    -1,   115,    -1,   117,    -1,
      -1,    -1,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,   133,   134,    -1,    -1,   137,    -1,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,    16,    -1,    -1,   157,    -1,
      -1,    -1,    23,    -1,    -1,    26,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    -1,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    -1,    -1,   110,
     111,   112,   113,    -1,   115,    -1,   117,    -1,    -1,    -1,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   132,   133,    -1,    -1,    -1,   137,    -1,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,    16,    -1,    -1,   157,    -1,    -1,    -1,
      23,    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    -1,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    -1,    -1,   110,   111,   112,
     113,    -1,   115,    -1,   117,    -1,    -1,    -1,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   137,    -1,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    16,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,
      -1,    26,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    17,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    -1,    -1,   110,   111,   112,   113,    -1,
     115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,   117,    -1,    -1,   120,
     121,   122,    -1,    -1,   149,   150,   151,   152,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    17,
     151,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,   117,    -1,    -1,   120,   121,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   137,    -1,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   115,   151,   117,   153,    -1,    -1,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,    -1,    -1,    -1,    -1,   115,    -1,   117,
      -1,    -1,    -1,   121,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,
      -1,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   115,   116,   117,    -1,
      -1,    -1,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   115,   151,   117,   153,    -1,    -1,   121,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   137,    -1,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    15,   159,   160,   163,   166,   167,   149,     0,    51,
      52,    53,    54,    55,    58,    59,    63,    64,    65,   108,
     161,   165,   193,   198,   199,   201,   203,   204,   208,   209,
     210,   211,   168,     4,     5,    57,   119,   191,   212,    57,
     119,   212,   149,    56,   202,   202,   202,   202,   202,   202,
     202,     3,     7,     8,     9,   162,   169,   171,   187,   188,
     190,   155,   164,    14,    18,   149,   151,   214,   215,   216,
     306,   119,   241,   119,    17,   115,   117,   121,   122,   137,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     153,   195,   196,   197,   239,   267,   268,   276,   277,   278,
     281,   283,   286,   302,   303,   304,   305,   306,   307,     5,
     191,   217,   218,   241,   119,   197,   218,    51,    52,    17,
      18,    61,    66,   192,   200,    17,   149,   192,   200,   149,
     205,    61,   149,   206,   206,   206,    10,    11,   115,   134,
     172,   173,   174,   283,   134,   189,   282,   283,   306,   119,
     212,   213,   265,   213,    72,   233,   213,   163,   166,   154,
     216,   170,   171,   242,   243,   248,   268,    17,   194,   248,
     282,   116,   276,   279,   280,   281,    27,   118,   269,   275,
     282,   154,   284,   284,   123,   138,   120,   196,   156,   269,
     271,   269,   241,   194,   120,   119,    57,   119,    61,   149,
      60,   149,    62,    62,    62,   172,   172,    16,    23,    26,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    43,    44,    45,    46,    47,    48,    49,
      67,    69,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   110,   111,   112,   113,   115,   117,   132,
     133,   150,   152,   157,   175,   178,   179,   180,   181,   182,
     185,   186,   261,   262,   283,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   306,   114,   174,   213,   114,   213,   282,   266,   267,
       5,   213,   217,   234,   283,   217,   149,   120,   217,   120,
       6,    17,    19,    74,    75,    96,   109,   241,   244,   245,
     246,   249,   250,   251,   252,   253,   254,   256,   257,   258,
     156,   149,   120,   119,   116,   280,   118,   272,   274,   280,
     306,   217,   266,   120,   218,   197,   119,   197,    61,   149,
     192,   207,   206,   206,   206,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   263,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   287,   294,   294,   294,
      68,   124,   125,    70,    71,   126,   127,   128,   129,   130,
     131,   132,   133,   304,   305,   134,   135,   264,   287,   115,
     174,   218,   282,   218,   120,   119,   217,   119,   283,    41,
     219,   223,   219,   241,   282,   115,   259,   261,   295,   296,
     306,   202,   241,   115,   115,    13,   245,   156,   247,   243,
     119,   267,   155,   270,   114,   273,   120,   194,   120,   283,
     287,   287,   287,   287,   287,   287,   287,   116,   287,   287,
     287,   287,   287,   287,   287,   287,    10,   176,   176,   176,
     176,   176,   176,   176,   264,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   184,   287,   287,   287,   287,   287,   287,   287,
     287,   116,   287,   287,   287,   287,   287,   287,   116,   116,
     287,   287,   116,   121,   122,   284,   285,   289,   290,    71,
     263,   291,   291,   291,   291,   291,   291,   291,   291,   292,
     292,   114,   116,   176,   219,   219,   267,   219,   115,   235,
     236,   237,    22,    42,   226,   241,   282,   287,   283,   241,
     255,   243,   248,   120,   271,   272,    52,   218,   120,   218,
     116,   114,   114,   114,   114,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   114,   134,   177,   287,   287,
     287,   287,   287,   184,   287,   116,   114,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   114,   116,   116,   114,
     114,   114,   116,   114,   116,   114,   114,   114,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     284,   284,   116,   263,   287,   264,   120,    73,   116,   148,
     238,   239,   240,   302,   306,   120,   237,   115,   220,   222,
     261,   283,   296,   224,   225,   259,    21,   228,   241,    68,
     136,    13,   120,   119,   287,   287,   287,   287,   287,   116,
     116,   116,   116,   116,   155,   183,   116,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   155,   260,   219,   116,
     240,   287,   222,   224,    22,    12,    20,   227,   231,   232,
     283,   287,   241,   197,   114,   116,   116,   116,   116,   116,
      50,   116,   114,   114,   116,   116,   116,   116,   116,   116,
     114,   116,    68,   221,    24,    25,   229,   230,   261,   283,
     295,   296,   142,   142,   232,   231,   116,   116,   120,   287,
     126,   287,   287,   287,   283,   116,   295,   295,   230,   218,
     116,   137,   116,   116,   114,   116,   287,   116
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 137: /* "\"string\"" */

/* Line 1000 of yacc.c  */
#line 366 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(char*, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2499 "sparql_parser.c"
	break;
      case 139: /* "\"double literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2511 "sparql_parser.c"
	break;
      case 140: /* "\"double positive literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2523 "sparql_parser.c"
	break;
      case 141: /* "\"double negative literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2535 "sparql_parser.c"
	break;
      case 142: /* "\"integer literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2547 "sparql_parser.c"
	break;
      case 143: /* "\"integer positive literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2559 "sparql_parser.c"
	break;
      case 144: /* "\"integer negative literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2571 "sparql_parser.c"
	break;
      case 145: /* "\"decimal literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2583 "sparql_parser.c"
	break;
      case 146: /* "\"decimal positive literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2595 "sparql_parser.c"
	break;
      case 147: /* "\"decimal negative literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2607 "sparql_parser.c"
	break;
      case 148: /* "\"boolean literal\"" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2619 "sparql_parser.c"
	break;
      case 149: /* "\"URI literal\"" */

/* Line 1000 of yacc.c  */
#line 355 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2631 "sparql_parser.c"
	break;
      case 150: /* "\"URI literal (\"" */

/* Line 1000 of yacc.c  */
#line 355 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2643 "sparql_parser.c"
	break;
      case 151: /* "\"QName literal\"" */

/* Line 1000 of yacc.c  */
#line 366 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(char*, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2655 "sparql_parser.c"
	break;
      case 152: /* "\"QName literal (\"" */

/* Line 1000 of yacc.c  */
#line 366 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(char*, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2667 "sparql_parser.c"
	break;
      case 153: /* "\"blank node literal\"" */

/* Line 1000 of yacc.c  */
#line 366 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(char*, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2679 "sparql_parser.c"
	break;
      case 154: /* "\"identifier\"" */

/* Line 1000 of yacc.c  */
#line 366 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(char*, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2691 "sparql_parser.c"
	break;
      case 169: /* "SelectQuery" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2703 "sparql_parser.c"
	break;
      case 170: /* "SubSelect" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2715 "sparql_parser.c"
	break;
      case 171: /* "SelectClause" */

/* Line 1000 of yacc.c  */
#line 470 "./sparql_parser.y"
	{
  if((yyvaluep->projection))
    rasqal_free_projection((yyvaluep->projection));
};

/* Line 1000 of yacc.c  */
#line 2727 "sparql_parser.c"
	break;
      case 172: /* "SelectExpressionList" */

/* Line 1000 of yacc.c  */
#line 470 "./sparql_parser.y"
	{
  if((yyvaluep->projection))
    rasqal_free_projection((yyvaluep->projection));
};

/* Line 1000 of yacc.c  */
#line 2739 "sparql_parser.c"
	break;
      case 173: /* "SelectExpressionListTail" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2751 "sparql_parser.c"
	break;
      case 174: /* "SelectTerm" */

/* Line 1000 of yacc.c  */
#line 446 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 2763 "sparql_parser.c"
	break;
      case 175: /* "AggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2775 "sparql_parser.c"
	break;
      case 177: /* "ExpressionOrStar" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2787 "sparql_parser.c"
	break;
      case 178: /* "CountAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2799 "sparql_parser.c"
	break;
      case 179: /* "SumAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2811 "sparql_parser.c"
	break;
      case 180: /* "AvgAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2823 "sparql_parser.c"
	break;
      case 181: /* "MinAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2835 "sparql_parser.c"
	break;
      case 182: /* "MaxAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2847 "sparql_parser.c"
	break;
      case 183: /* "SeparatorOpt" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2859 "sparql_parser.c"
	break;
      case 185: /* "GroupConcatAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2871 "sparql_parser.c"
	break;
      case 186: /* "SampleAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2883 "sparql_parser.c"
	break;
      case 187: /* "ConstructQuery" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2895 "sparql_parser.c"
	break;
      case 188: /* "DescribeQuery" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2907 "sparql_parser.c"
	break;
      case 189: /* "VarOrIRIrefList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2919 "sparql_parser.c"
	break;
      case 191: /* "DatasetClause" */

/* Line 1000 of yacc.c  */
#line 452 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 2931 "sparql_parser.c"
	break;
      case 194: /* "GraphTriples" */

/* Line 1000 of yacc.c  */
#line 389 "./sparql_parser.y"
	{
  if((yyvaluep->update))
    rasqal_free_update_operation((yyvaluep->update));
};

/* Line 1000 of yacc.c  */
#line 2943 "sparql_parser.c"
	break;
      case 195: /* "GraphTemplate" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2955 "sparql_parser.c"
	break;
      case 196: /* "ModifyTemplate" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2967 "sparql_parser.c"
	break;
      case 197: /* "ModifyTemplateList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2979 "sparql_parser.c"
	break;
      case 200: /* "GraphRefAll" */

/* Line 1000 of yacc.c  */
#line 361 "./sparql_parser.y"
	{
  if((yyvaluep->uri_applies)->uri)
    raptor_free_uri((yyvaluep->uri_applies)->uri);
};

/* Line 1000 of yacc.c  */
#line 2991 "sparql_parser.c"
	break;
      case 205: /* "IriRefList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3003 "sparql_parser.c"
	break;
      case 212: /* "DatasetClauseList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3015 "sparql_parser.c"
	break;
      case 213: /* "DatasetClauseListOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3027 "sparql_parser.c"
	break;
      case 214: /* "DefaultGraphClause" */

/* Line 1000 of yacc.c  */
#line 452 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 3039 "sparql_parser.c"
	break;
      case 215: /* "NamedGraphClause" */

/* Line 1000 of yacc.c  */
#line 452 "./sparql_parser.y"
	{
  if((yyvaluep->data_graph))
    rasqal_free_data_graph((yyvaluep->data_graph));
};

/* Line 1000 of yacc.c  */
#line 3051 "sparql_parser.c"
	break;
      case 216: /* "SourceSelector" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3063 "sparql_parser.c"
	break;
      case 219: /* "SolutionModifier" */

/* Line 1000 of yacc.c  */
#line 464 "./sparql_parser.y"
	{
  if((yyvaluep->modifier))
    rasqal_free_solution_modifier((yyvaluep->modifier));
};

/* Line 1000 of yacc.c  */
#line 3075 "sparql_parser.c"
	break;
      case 220: /* "GroupConditionList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3087 "sparql_parser.c"
	break;
      case 221: /* "AsVarOpt" */

/* Line 1000 of yacc.c  */
#line 446 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3099 "sparql_parser.c"
	break;
      case 222: /* "GroupCondition" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3111 "sparql_parser.c"
	break;
      case 223: /* "GroupClauseOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3123 "sparql_parser.c"
	break;
      case 224: /* "HavingCondition" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3135 "sparql_parser.c"
	break;
      case 225: /* "HavingConditionList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3147 "sparql_parser.c"
	break;
      case 226: /* "HavingClauseOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3159 "sparql_parser.c"
	break;
      case 228: /* "OrderClauseOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3171 "sparql_parser.c"
	break;
      case 229: /* "OrderConditionList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3183 "sparql_parser.c"
	break;
      case 230: /* "OrderCondition" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3195 "sparql_parser.c"
	break;
      case 233: /* "BindingsClauseOpt" */

/* Line 1000 of yacc.c  */
#line 477 "./sparql_parser.y"
	{
  if((yyvaluep->bindings))
    rasqal_free_bindings((yyvaluep->bindings));
};

/* Line 1000 of yacc.c  */
#line 3207 "sparql_parser.c"
	break;
      case 234: /* "VarList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3219 "sparql_parser.c"
	break;
      case 235: /* "BindingsRowListOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3231 "sparql_parser.c"
	break;
      case 236: /* "BindingsRowList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3243 "sparql_parser.c"
	break;
      case 237: /* "BindingsRow" */

/* Line 1000 of yacc.c  */
#line 458 "./sparql_parser.y"
	{
  if((yyvaluep->row))
    rasqal_free_row((yyvaluep->row));
};

/* Line 1000 of yacc.c  */
#line 3255 "sparql_parser.c"
	break;
      case 238: /* "BindingValueList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3267 "sparql_parser.c"
	break;
      case 239: /* "RDFLiteral" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3279 "sparql_parser.c"
	break;
      case 240: /* "BindingValue" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3291 "sparql_parser.c"
	break;
      case 241: /* "GroupGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3303 "sparql_parser.c"
	break;
      case 242: /* "GroupGraphPatternSub" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3315 "sparql_parser.c"
	break;
      case 243: /* "TriplesBlockOpt" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3327 "sparql_parser.c"
	break;
      case 244: /* "GraphPatternListOpt" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3339 "sparql_parser.c"
	break;
      case 245: /* "GraphPatternList" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3351 "sparql_parser.c"
	break;
      case 246: /* "GraphPatternListFilter" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3363 "sparql_parser.c"
	break;
      case 248: /* "TriplesBlock" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3375 "sparql_parser.c"
	break;
      case 249: /* "GraphPatternNotTriples" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3387 "sparql_parser.c"
	break;
      case 250: /* "OptionalGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3399 "sparql_parser.c"
	break;
      case 251: /* "GraphGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3411 "sparql_parser.c"
	break;
      case 252: /* "ServiceGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3423 "sparql_parser.c"
	break;
      case 253: /* "MinusGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3435 "sparql_parser.c"
	break;
      case 254: /* "GroupOrUnionGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3447 "sparql_parser.c"
	break;
      case 255: /* "GroupOrUnionGraphPatternList" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3459 "sparql_parser.c"
	break;
      case 256: /* "LetGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3471 "sparql_parser.c"
	break;
      case 257: /* "BindGraphPattern" */

/* Line 1000 of yacc.c  */
#line 406 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 3483 "sparql_parser.c"
	break;
      case 258: /* "Filter" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3495 "sparql_parser.c"
	break;
      case 259: /* "Constraint" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3507 "sparql_parser.c"
	break;
      case 260: /* "ParamsOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3519 "sparql_parser.c"
	break;
      case 261: /* "FunctionCall" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3531 "sparql_parser.c"
	break;
      case 262: /* "CoalesceExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3543 "sparql_parser.c"
	break;
      case 263: /* "ArgList" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3555 "sparql_parser.c"
	break;
      case 264: /* "ArgListNoBraces" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3567 "sparql_parser.c"
	break;
      case 265: /* "ConstructTemplate" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3579 "sparql_parser.c"
	break;
      case 266: /* "ConstructTriplesOpt" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3591 "sparql_parser.c"
	break;
      case 267: /* "ConstructTriples" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3603 "sparql_parser.c"
	break;
      case 268: /* "TriplesSameSubject" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3615 "sparql_parser.c"
	break;
      case 269: /* "PropertyListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3627 "sparql_parser.c"
	break;
      case 270: /* "PropertyListTailOpt" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3639 "sparql_parser.c"
	break;
      case 271: /* "PropertyList" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3651 "sparql_parser.c"
	break;
      case 272: /* "ObjectList" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3663 "sparql_parser.c"
	break;
      case 273: /* "ObjectTail" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3675 "sparql_parser.c"
	break;
      case 274: /* "Object" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3687 "sparql_parser.c"
	break;
      case 275: /* "Verb" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3699 "sparql_parser.c"
	break;
      case 276: /* "TriplesNode" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3711 "sparql_parser.c"
	break;
      case 277: /* "BlankNodePropertyList" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3723 "sparql_parser.c"
	break;
      case 278: /* "Collection" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3735 "sparql_parser.c"
	break;
      case 279: /* "GraphNodeListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 372 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3747 "sparql_parser.c"
	break;
      case 280: /* "GraphNode" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3759 "sparql_parser.c"
	break;
      case 281: /* "VarOrTerm" */

/* Line 1000 of yacc.c  */
#line 395 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3771 "sparql_parser.c"
	break;
      case 282: /* "VarOrIRIref" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3783 "sparql_parser.c"
	break;
      case 283: /* "Var" */

/* Line 1000 of yacc.c  */
#line 446 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3795 "sparql_parser.c"
	break;
      case 284: /* "VarName" */

/* Line 1000 of yacc.c  */
#line 446 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3807 "sparql_parser.c"
	break;
      case 286: /* "GraphTerm" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3819 "sparql_parser.c"
	break;
      case 287: /* "Expression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3831 "sparql_parser.c"
	break;
      case 288: /* "ConditionalOrExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3843 "sparql_parser.c"
	break;
      case 289: /* "ConditionalAndExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3855 "sparql_parser.c"
	break;
      case 290: /* "RelationalExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3867 "sparql_parser.c"
	break;
      case 291: /* "AdditiveExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3879 "sparql_parser.c"
	break;
      case 292: /* "MultiplicativeExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3891 "sparql_parser.c"
	break;
      case 293: /* "UnaryExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3903 "sparql_parser.c"
	break;
      case 294: /* "PrimaryExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3915 "sparql_parser.c"
	break;
      case 295: /* "BrackettedExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3927 "sparql_parser.c"
	break;
      case 296: /* "BuiltInCall" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3939 "sparql_parser.c"
	break;
      case 298: /* "RegexExpression" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3951 "sparql_parser.c"
	break;
      case 299: /* "DatetimeBuiltinAccessors" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3963 "sparql_parser.c"
	break;
      case 300: /* "DatetimeExtensions" */

/* Line 1000 of yacc.c  */
#line 418 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3975 "sparql_parser.c"
	break;
      case 301: /* "IRIrefBrace" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3987 "sparql_parser.c"
	break;
      case 302: /* "NumericLiteral" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3999 "sparql_parser.c"
	break;
      case 303: /* "NumericLiteralUnsigned" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4011 "sparql_parser.c"
	break;
      case 304: /* "NumericLiteralPositive" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4023 "sparql_parser.c"
	break;
      case 305: /* "NumericLiteralNegative" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4035 "sparql_parser.c"
	break;
      case 306: /* "IRIref" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4047 "sparql_parser.c"
	break;
      case 307: /* "BlankNode" */

/* Line 1000 of yacc.c  */
#line 435 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 4059 "sparql_parser.c"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1455 of yacc.c  */
#line 499 "./sparql_parser.y"
    {
  if((yyvsp[(4) - (4)].bindings))
    ((rasqal_query*)rq)->bindings = (yyvsp[(4) - (4)].bindings);
}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 508 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(sparql->experimental)
    ((rasqal_query*)rq)->explain = 1;
  else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "EXPLAIN can only used with LAQRS");
    YYERROR;
  }
}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 521 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 529 "./sparql_parser.y"
    {
  raptor_sequence* seq;
  rasqal_graph_pattern* where_gp;

  /* Query graph pattern is first GP inside sequence of sub-GPs */
  seq = rasqal_graph_pattern_get_sub_graph_pattern_sequence((yyvsp[(1) - (1)].graph_pattern));
  where_gp = (rasqal_graph_pattern*)raptor_sequence_delete_at(seq, 0);

  rasqal_query_store_select_query(((rasqal_query*)rq),
                                  (yyvsp[(1) - (1)].graph_pattern)->projection,
                                  (yyvsp[(1) - (1)].graph_pattern)->data_graphs,
                                  where_gp,
                                  (yyvsp[(1) - (1)].graph_pattern)->modifier);
  (yyvsp[(1) - (1)].graph_pattern)->projection = NULL;
  (yyvsp[(1) - (1)].graph_pattern)->data_graphs = NULL;
  (yyvsp[(1) - (1)].graph_pattern)->modifier = NULL;

  rasqal_free_graph_pattern((yyvsp[(1) - (1)].graph_pattern));
}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 549 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->constructs = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_CONSTRUCT;
}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 554 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->describes = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DESCRIBE;
}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 559 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_ASK;
}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 577 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DELETE;
}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 581 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_INSERT;
}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 585 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 589 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 593 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 597 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 601 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 605 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 609 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 613 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 621 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 629 "./sparql_parser.y"
    {
  rasqal_query_set_base_uri((rasqal_query*)rq, (yyvsp[(2) - (2)].uri));
}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 633 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 641 "./sparql_parser.y"
    {
  raptor_sequence *seq = ((rasqal_query*)rq)->prefixes;
  unsigned const char* prefix_string = (yyvsp[(3) - (4)].name);
  size_t prefix_length = 0;

  if(prefix_string)
    prefix_length = strlen((const char*)prefix_string);
  
  if(raptor_namespaces_find_namespace(((rasqal_query*)rq)->namespaces,
                                      prefix_string, (int)prefix_length)) {
    /* A prefix may be defined only once */
    sparql_syntax_warning(((rasqal_query*)rq), 
                          "PREFIX %s can be defined only once.",
                          prefix_string ? (const char*)prefix_string : ":");
    RASQAL_FREE(char*, prefix_string);
    raptor_free_uri((yyvsp[(4) - (4)].uri));
  } else {
    rasqal_prefix *p;
    p = rasqal_new_prefix(((rasqal_query*)rq)->world, prefix_string, (yyvsp[(4) - (4)].uri));
    if(!p)
      YYERROR_MSG("PrefixDeclOpt: failed to create new prefix");
    if(raptor_sequence_push(seq, p))
      YYERROR_MSG("PrefixDeclOpt: cannot push prefix to seq");
    if(rasqal_query_declare_prefix(((rasqal_query*)rq), p)) {
      YYERROR_MSG("PrefixDeclOpt: cannot declare prefix");
    }
  }
}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 670 "./sparql_parser.y"
    {
  /* nothing to do, rq->prefixes already initialised */
}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 678 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.graph_pattern) = NULL;
  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SELECT can only be used with a SPARQL query");
    YYERROR;
  } else {
    (yyval.graph_pattern) = rasqal_new_select_graph_pattern((rasqal_query*)rq,
                                         (yyvsp[(1) - (4)].projection), (yyvsp[(2) - (4)].seq), (yyvsp[(3) - (4)].graph_pattern), (yyvsp[(4) - (4)].modifier));
  }
}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 696 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (3)].projection) && (yyvsp[(2) - (3)].graph_pattern) && (yyvsp[(3) - (3)].modifier))
    (yyval.graph_pattern) = rasqal_new_select_graph_pattern((rasqal_query*)rq,
                                         (yyvsp[(1) - (3)].projection),
                                         /* data graphs */ NULL,
                                         (yyvsp[(2) - (3)].graph_pattern),
                                         (yyvsp[(3) - (3)].modifier));
  else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 710 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(3) - (3)].projection);
  (yyval.projection)->distinct = 1;
}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 715 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(3) - (3)].projection);
  (yyval.projection)->distinct = 2;
}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 720 "./sparql_parser.y"
    {
  (yyval.projection) = (yyvsp[(2) - (2)].projection);
}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 730 "./sparql_parser.y"
    {
  (yyval.projection) = rasqal_new_projection((rasqal_query*)rq, (yyvsp[(1) - (1)].seq), 0, 0);
}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 734 "./sparql_parser.y"
    {
  (yyval.projection) = rasqal_new_projection((rasqal_query*)rq, NULL, /* wildcard */ 1, 0);
}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 744 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 1: sequence push failed");
  }
}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 753 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 2: sequence push failed");
  }
}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 762 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_variable,
                           (raptor_data_print_handler)rasqal_variable_print);
  if(!(yyval.seq))
    YYERROR_MSG("SelectExpressionListTail 3: failed to create sequence");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 3: sequence push failed");
  }
}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 780 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 784 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.variable) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SELECT ( expression ) AS Variable cannot be used with SPARQL 1.0");
    YYERROR;
  } else if((yyvsp[(2) - (5)].expr) && (yyvsp[(4) - (5)].variable)) {
    if(rasqal_expression_mentions_variable((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, 
                              "Expression in SELECT ( expression ) AS %s contains the variable name '%s'",
                              (yyvsp[(4) - (5)].variable)->name, (yyvsp[(4) - (5)].variable)->name);
      YYERROR;
    } else {
      (yyval.variable) = (yyvsp[(4) - (5)].variable);
      (yyval.variable)->expression = (yyvsp[(2) - (5)].expr);
    }

  }
}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 826 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 830 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 834 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 838 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 842 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 846 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 850 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 857 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "functions with DISTINCT cannot be used with SPARQL 1.0");
    YYERROR;
  }
  
  (yyval.uinteger) = RASQAL_EXPR_FLAG_DISTINCT;
}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 870 "./sparql_parser.y"
    {
  (yyval.uinteger) = 0;
}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 877 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 881 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_VARSTAR);
}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 889 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COUNT() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_COUNT, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("CountAggregateExpression: cannot create expr");
  }
}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 910 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SUM() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SUM, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SumAggregateExpression: cannot create expr");
  }
}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 931 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "AVG() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_AVG, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("AvgAggregateExpression: cannot create expr");
  }
}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 952 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MIN() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MIN, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MinAggregateExpression: cannot create expr");
  }
}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 973 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MAX() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MAX, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MaxAggregateExpression: cannot create expr");
  }
}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 994 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(4) - (4)].name), 
	                         NULL /* language */,
                                 NULL /* dt uri */, NULL /* dt_qname */);
}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1000 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1010 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 1: sequence push failed");
  }
}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1019 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq))
    YYERROR_MSG("ExpressionList 2: failed to create sequence");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 2: sequence push failed");
  }
}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1035 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP_CONCAT() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    int flags = 0;
    
    if((yyvsp[(3) - (6)].uinteger))
      flags |= RASQAL_EXPR_FLAG_DISTINCT;

    (yyval.expr) = rasqal_new_group_concat_expression(((rasqal_query*)rq)->world,
                                            flags /* flags */,
                                            (yyvsp[(4) - (6)].seq) /* args */,
                                            (yyvsp[(5) - (6)].literal) /* separator */);
    if(!(yyval.expr))
      YYERROR_MSG("GroupConcatAggregateExpression: cannot create expr");
  }
}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1063 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_aggregates) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SAMPLE() cannot be used with SPARQL 1.0");
    YYERROR;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SAMPLE, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SampleAggregateExpression: cannot create expr");
  }
}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1086 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CONSTRUCT can only be used with a SPARQL query");
    YYERROR;
  }
  
  (yyval.seq) = (yyvsp[(2) - (5)].seq);

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1108 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_graph_pattern* where_gp;
  raptor_sequence* seq = NULL;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CONSTRUCT can only be used with a SPARQL query");
    YYERROR;
  }

  if((yyvsp[(5) - (7)].seq)) {
    int i;
    int size = raptor_sequence_size((yyvsp[(5) - (7)].seq));
    
    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                              (raptor_data_print_handler)rasqal_triple_print);
    for(i = 0; i < size; i++) {
      rasqal_triple* t = (rasqal_triple*)raptor_sequence_get_at((yyvsp[(5) - (7)].seq), i);
      t = rasqal_new_triple_from_triple(t);
      raptor_sequence_push(seq, t);
    }
  }
  
  where_gp = rasqal_new_basic_graph_pattern_from_triples((rasqal_query*)rq, seq);
  seq = NULL;
  if(!(yyval.seq))
    YYERROR_MSG("ConstructQuery: cannot create graph pattern");

  (yyval.seq) = (yyvsp[(5) - (7)].seq);

  if((yyvsp[(2) - (7)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (7)].seq));
  ((rasqal_query*)rq)->query_graph_pattern = where_gp;

  if((yyvsp[(7) - (7)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(7) - (7)].modifier);
}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1154 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DESCRIBE can only be used with a SPARQL query");
    YYERROR;
  }
  
  (yyval.seq) = (yyvsp[(2) - (5)].seq);

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1178 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;

  if((yyvsp[(3) - (5)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(3) - (5)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);

  if((yyvsp[(5) - (5)].modifier))
    ((rasqal_query*)rq)->modifier = (yyvsp[(5) - (5)].modifier);
}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1194 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 1: sequence push failed");
  }
}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1203 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 2: sequence push failed");
  }
}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1212 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
  if(!(yyval.seq))
    YYERROR_MSG("VarOrIRIrefList 3: cannot create seq");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 3: sequence push failed");
  }
}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1229 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "ASK can only be used with a SPARQL query");
    YYERROR;
  }
  
  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1249 "./sparql_parser.y"
    {
  (yyval.data_graph) = (yyvsp[(2) - (2)].data_graph);
}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1253 "./sparql_parser.y"
    {
  (yyval.data_graph) = (yyvsp[(2) - (2)].data_graph);
}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1261 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(2) - (2)].uri);
}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1269 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "DELETE FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");

  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1289 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* SPARQL 1.1 (Draft) update:
   * deleting via template + query - not inline atomic triples 
   */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(3) - (5)].seq) /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("DeleteQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DeleteQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1321 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* SPARQL 1.1 (Draft) update:
   * deleting inline triples - not inserting from graph URIs 
   */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->delete_templates = (yyvsp[(4) - (5)].update)->insert_templates; (yyvsp[(4) - (5)].update)->insert_templates = NULL;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;
  
  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1341 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;
  raptor_sequence* delete_templates = NULL;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE WHERE { } can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* SPARQL 1.1 (Draft) update:
   * deleting via template - not inline atomic triples 
   */

  /* Turn GP into flattened triples */
  if((yyvsp[(3) - (3)].graph_pattern)) {
    delete_templates = rasqal_graph_pattern_get_flattened_triples((rasqal_query*)rq, (yyvsp[(3) - (3)].graph_pattern));
    rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
    (yyvsp[(3) - (3)].graph_pattern) = NULL;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       NULL /* insert templates */,
                                       delete_templates /* delete templates */,
                                       NULL /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("DeleteQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DeleteQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1385 "./sparql_parser.y"
    {
  (yyval.update) = NULL;
 
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     NULL /* graph_uri */,
                                     NULL /* document_uri */,
                                     (yyvsp[(1) - (1)].formula)->triples /* insert templates */, 
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */,
                                     RASQAL_UPDATE_GRAPH_ONE /* applies */);
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1402 "./sparql_parser.y"
    {
  (yyval.update) = NULL;

  if((yyvsp[(4) - (5)].formula)) {
    raptor_sequence* seq;
    seq = (yyvsp[(4) - (5)].formula)->triples;

    if((yyvsp[(2) - (5)].uri)) {
      rasqal_literal* origin_literal;
      
      origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (5)].uri));
      (yyvsp[(2) - (5)].uri) = NULL;

      rasqal_triples_sequence_set_origin(/* dest */ NULL, seq, origin_literal);
      rasqal_free_literal(origin_literal);
    }
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     NULL /* graph uri */,
                                     NULL /* document uri */,
                                     seq /* insert templates */,
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */,
                                     RASQAL_UPDATE_GRAPH_ONE /* applies */);
    (yyvsp[(4) - (5)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(4) - (5)].formula));
  }
}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1435 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(4) - (5)].seq);

  if((yyvsp[(2) - (5)].literal)) {
    rasqal_triples_sequence_set_origin(NULL, (yyval.seq), (yyvsp[(2) - (5)].literal));
    rasqal_free_literal((yyvsp[(2) - (5)].literal));
    (yyvsp[(2) - (5)].literal) = NULL;
  }
}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1450 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1454 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1462 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);

  if((yyvsp[(2) - (2)].seq)) {
    if(raptor_sequence_join((yyval.seq), (yyvsp[(2) - (2)].seq))) {
      raptor_free_sequence((yyvsp[(2) - (2)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ModifyTemplateList: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(2) - (2)].seq));
  }

}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1477 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1486 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql  = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "INSERT FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");

  if((yyvsp[(2) - (3)].seq))
    rasqal_query_add_data_graphs((rasqal_query*)rq, (yyvsp[(2) - (3)].seq));

  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1506 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* inserting via template + query - not inline atomic triples */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       (yyvsp[(3) - (5)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("InsertQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("InsertQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1536 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT DATA can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1559 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  if((yyvsp[(2) - (11)].uri)) {
    rasqal_literal* origin_literal;

    origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (11)].uri));
    (yyvsp[(2) - (11)].uri) = NULL;

    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(9) - (11)].seq), origin_literal);
    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(5) - (11)].seq), origin_literal);

    rasqal_free_literal(origin_literal);
  }

  /* after this $5, $9 and $12 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(9) - (11)].seq) /* insert templates */,
                                       (yyvsp[(5) - (11)].seq) /* delete templates */,
                                       (yyvsp[(11) - (11)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 1: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 1: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1602 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }
  
  if((yyvsp[(2) - (7)].uri)) {
    rasqal_literal* origin_literal;
    
    origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (7)].uri));
    (yyvsp[(2) - (7)].uri) = NULL;

    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(5) - (7)].seq), origin_literal);

    rasqal_free_literal(origin_literal);
  }
  
  /* after this $5 and $7 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(5) - (7)].seq) /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 2: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 2: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1644 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  if((yyvsp[(2) - (7)].uri)) {
    rasqal_literal* origin_literal;
    
    origin_literal = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(2) - (7)].uri));
    (yyvsp[(2) - (7)].uri) = NULL;

    rasqal_triples_sequence_set_origin(/* dest */ NULL, (yyvsp[(5) - (7)].seq), origin_literal);

    rasqal_free_literal(origin_literal);
  }

  /* after this $5 and $7 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(5) - (7)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 3: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 3: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1685 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "WITH can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(6) - (7)].update)->graph_uri = (yyvsp[(2) - (7)].uri); /* graph uri */
  (yyvsp[(6) - (7)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(6) - (7)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(6) - (7)].update));
}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1708 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies((yyvsp[(1) - (1)].uri), RASQAL_UPDATE_GRAPH_ONE);
}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1712 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_DEFAULT);
}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1716 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_NAMED);
}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1720 "./sparql_parser.y"
    {
  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_ALL);
}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1724 "./sparql_parser.y"
    {
  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CLEAR GRAPH DEFAULT is replaced by CLEAR DEFAULT in later SPARQL 1.1 drafts");


  (yyval.uri_applies) = new_uri_applies(NULL, RASQAL_UPDATE_GRAPH_DEFAULT);
}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1737 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR (SILENT) DEFAULT | NAMED | ALL can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  if((yyvsp[(3) - (3)].uri_applies)) {
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                         (yyvsp[(3) - (3)].uri_applies)->uri ? raptor_uri_copy((yyvsp[(3) - (3)].uri_applies)->uri) : NULL /* graph uri or NULL */,
                                         NULL /* document uri */,
                                         NULL, NULL,
                                         NULL /*where */,
                                         (yyvsp[(2) - (3)].integer) /* flags */,
                                         (yyvsp[(3) - (3)].uri_applies)->applies /* applies */);
    free_uri_applies((yyvsp[(3) - (3)].uri_applies));
    (yyvsp[(3) - (3)].uri_applies) = NULL;

    if(!update) {
      YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
    }
  }
}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1769 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CLEAR is replaced by CLEAR DEFAULT in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /* where */,
                                       0 /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1804 "./sparql_parser.y"
    {
  (yyval.integer) = RASQAL_UPDATE_FLAGS_SILENT;
}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1808 "./sparql_parser.y"
    {
  (yyval.integer) = 0;
}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1816 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE (SILENT) <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (3)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1843 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE (SILENT) GRAPH <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CREATE (SILENT) GRAPH <uri> is replaced by CREATE (SILENT) <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1878 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP (SILENT) DEFAULT | NAMED | ALL can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  if((yyvsp[(3) - (3)].uri_applies)) {
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                         (yyvsp[(3) - (3)].uri_applies)->uri ? raptor_uri_copy((yyvsp[(3) - (3)].uri_applies)->uri) : NULL /* graph uri or NULL */,
                                         NULL /* document uri */,
                                         NULL, NULL,
                                         NULL /*where */,
                                         (yyvsp[(2) - (3)].integer) /* flags */,
                                         (yyvsp[(3) - (3)].uri_applies)->applies /* applies */);
    free_uri_applies((yyvsp[(3) - (3)].uri_applies));
    (yyvsp[(3) - (3)].uri_applies) = NULL;

    if(!update) {
      YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
    }
  }
}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1914 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1923 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)raptor_free_uri,
                           (raptor_data_print_handler)raptor_uri_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].uri))
      raptor_free_uri((yyvsp[(1) - (1)].uri));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1942 "./sparql_parser.y"
    {
  (yyval.uri) = NULL;
}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1946 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1953 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1957 "./sparql_parser.y"
    {
  /* Early draft syntax allowed a list of URIs - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "LOAD <document uri list> INTO <graph uri> is replaced by LOAD <document uri> INTO GRAPH <graph uri> in later SPARQL 1.1 drafts");

  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1965 "./sparql_parser.y"
    {
  /* Early draft syntax allowed a list of URIs - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "LOAD <document uri list> INTO DEFAULT is replaced by LOAD <document uri> in later SPARQL 1.1 drafts");

  (yyval.uri) = NULL;
}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1977 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                       NULL /* graph uri */, 
                                       (yyvsp[(3) - (3)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /* where */,
                                       (yyvsp[(2) - (3)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 2004 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  int i;
  raptor_uri* doc_uri;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <document uri> INTO GRAPH <graph URI> / DEFAULT can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  for(i = 0; (doc_uri = (raptor_uri*)raptor_sequence_get_at((yyvsp[(3) - (5)].seq), i)); i++) {
    rasqal_update_operation* update;
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                         (yyvsp[(5) - (5)].uri) ? raptor_uri_copy((yyvsp[(5) - (5)].uri)) : NULL /* graph uri */,
                                         raptor_uri_copy(doc_uri) /* document uri */,
                                         NULL, NULL,
                                         NULL /*where */,
                                         (yyvsp[(2) - (5)].integer) /* flags */,
                                         RASQAL_UPDATE_GRAPH_ONE /* applies */);
    if(!update) {
      YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
    }

    if(i == 1)
      /* Early draft syntax allowed a list of URIs - deprecated */
      sparql_syntax_warning((rasqal_query*)rq,
                            "LOAD <document uri list> INTO <graph uri> / DEFAULT is replaced by LOAD <document uri> INTO GRAPH <graph uri> or LOAD <document uri> in later SPARQL 1.1 drafts");
    

  }

  raptor_free_sequence((yyvsp[(3) - (5)].seq));
  if((yyvsp[(5) - (5)].uri))
    raptor_free_uri((yyvsp[(5) - (5)].uri));
}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 2050 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "ADD (SILENT) <uri> TO <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_ADD,
                                       (yyvsp[(3) - (5)].uri) /* graph uri or NULL */, 
                                       (yyvsp[(5) - (5)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (5)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("AddQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("AddQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 2081 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MOVE (SILENT) <uri> TO <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_MOVE,
                                       (yyvsp[(3) - (5)].uri) /* graph uri or NULL */, 
                                       (yyvsp[(5) - (5)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (5)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("MoveQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("MoveQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 2112 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->sparql11_update) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COPY (SILENT) <uri> TO <uri> can only be used with a SPARQL 1.1 Update");
    YYERROR;
  }

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_COPY,
                                       (yyvsp[(3) - (5)].uri) /* graph uri or NULL */, 
                                       (yyvsp[(5) - (5)].uri) /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       (yyvsp[(2) - (5)].integer) /* flags */,
                                       RASQAL_UPDATE_GRAPH_ONE /* applies */);
  if(!update) {
    YYERROR_MSG("CopyQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CopyQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 2143 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(1) - (2)].seq) && (yyvsp[(2) - (2)].data_graph))
    raptor_sequence_push((yyvsp[(1) - (2)].seq), (yyvsp[(2) - (2)].data_graph));
}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 2149 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_data_graph, (raptor_data_print_handler)rasqal_data_graph_print);
  if((yyval.seq) && (yyvsp[(1) - (1)].data_graph))
    raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].data_graph));
}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 2158 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 2162 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 2170 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (1)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (1)].literal));
    rasqal_data_graph* dg;

    dg = rasqal_new_data_graph_from_uri(((rasqal_query*)rq)->world, uri,
                                        NULL, RASQAL_DATA_GRAPH_BACKGROUND,
                                        NULL, NULL, NULL);

    if(!dg) {
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
      YYERROR_MSG("DefaultGraphClause: rasqal_query_new_data_graph_from_uri() failed");
    }
    rasqal_free_literal((yyvsp[(1) - (1)].literal));

    (yyval.data_graph) = dg;
  } else
    (yyval.data_graph) = NULL;
}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 2194 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (2)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(2) - (2)].literal));
    rasqal_data_graph* dg;

    dg = rasqal_new_data_graph_from_uri(((rasqal_query*)rq)->world, uri,
                                        uri, RASQAL_DATA_GRAPH_NAMED,
                                        NULL, NULL, NULL);
    
    if(!dg) {
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
      YYERROR_MSG("NamedGraphClause: rasqal_query_new_data_graph_from_uri() failed");
    }
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
    (yyval.data_graph) = dg;
  } else
    (yyval.data_graph) = NULL;
}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 2217 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 2225 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 2229 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 2237 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 2241 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 2249 "./sparql_parser.y"
    {
  (yyval.modifier) = rasqal_new_solution_modifier((rasqal_query*)rq,
                                    /* order_conditions */ (yyvsp[(3) - (4)].seq),
                                    /* group_conditions */ (yyvsp[(1) - (4)].seq),
                                    /* having_conditions */ (yyvsp[(2) - (4)].seq),
                                    /* limit */ (yyvsp[(4) - (4)].limit_offset)[0],
                                    /* offset */ (yyvsp[(4) - (4)].limit_offset)[1]);
  
}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 2263 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 1: sequence push failed");
    }
}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 2273 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("GroupConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 2: sequence push failed");
    }
}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 2293 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 2297 "./sparql_parser.y"
    {
  (yyval.variable) = NULL;
}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 2305 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 2309 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 2313 "./sparql_parser.y"
    {
  rasqal_literal* l;

  (yyval.expr) = (yyvsp[(2) - (4)].expr);
  if((yyvsp[(3) - (4)].variable)) {
    if(rasqal_expression_mentions_variable((yyval.expr), (yyvsp[(3) - (4)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, 
                              "Expression in GROUP BY ( expression ) AS %s contains the variable name '%s'",
                              (yyvsp[(3) - (4)].variable)->name, (yyvsp[(3) - (4)].variable)->name);
    } else {
      /* Expression AS Variable */
      (yyvsp[(3) - (4)].variable)->expression = (yyval.expr);
      (yyval.expr) = NULL;
      
      l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
      if(!l)
        YYERROR_MSG("GroupCondition 4: cannot create variable literal");
      (yyvsp[(3) - (4)].variable) = NULL;

      (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
      if(!(yyval.expr))
        YYERROR_MSG("GroupCondition 4: cannot create variable literal expression");
    }
  }
  
}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 2340 "./sparql_parser.y"
    {
  rasqal_literal* l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("GroupCondition 5: cannot create lit");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("GroupCondition 5: cannot create lit expr");
}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 2354 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP BY cannot be used with SPARQL 1.0");
    YYERROR;
  } else
    (yyval.seq) = (yyvsp[(3) - (3)].seq);
}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 2367 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 2375 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 2382 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 1: sequence push failed");
    }
}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 2392 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("HavingConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 2: sequence push failed");
    }
}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 2412 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.seq) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "HAVING cannot be used with SPARQL 1.0");
    YYERROR;
  } else 
    (yyval.seq) = (yyvsp[(2) - (2)].seq);
}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 2425 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 2433 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(1) - (2)].integer);
  (yyval.limit_offset)[1] = (yyvsp[(2) - (2)].integer);
}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 2438 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(2) - (2)].integer);
  (yyval.limit_offset)[1] = (yyvsp[(1) - (2)].integer);
}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 2443 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = (yyvsp[(1) - (1)].integer);
  (yyval.limit_offset)[1] = -1;
}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 2448 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = -1;
  (yyval.limit_offset)[1] = (yyvsp[(1) - (1)].integer);
}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 2453 "./sparql_parser.y"
    {
  (yyval.limit_offset)[0] = -1;
  (yyval.limit_offset)[1] = -1;
}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 2462 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(3) - (3)].seq);
}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 2466 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 2474 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 1: sequence push failed");
    }
}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 2484 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("OrderConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 2: sequence push failed");
    }
}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 2504 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 2511 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_DESC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 2: cannot create expr");
}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 2518 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 3: cannot create expr");
}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 2526 "./sparql_parser.y"
    {
  rasqal_literal* l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("OrderCondition 4: cannot create lit");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("OrderCondition 4: cannot create lit expr");

  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, e);
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 2543 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 5: cannot create expr");
}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 2551 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 6: cannot create expr");
}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 2563 "./sparql_parser.y"
    {
  (yyval.integer) = -1;

  if((yyvsp[(2) - (2)].literal) != NULL) {
    (yyval.integer) = (yyvsp[(2) - (2)].literal)->value.integer;
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
  
}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 2577 "./sparql_parser.y"
    {
  (yyval.integer) = -1;

  if((yyvsp[(2) - (2)].literal) != NULL) {
    (yyval.integer) = (yyvsp[(2) - (2)].literal)->value.integer;
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 2590 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (5)].seq)) {
    (yyval.bindings) = rasqal_new_bindings((rasqal_query*)rq, (yyvsp[(2) - (5)].seq), (yyvsp[(4) - (5)].seq));
    if(!(yyval.bindings))
      YYERROR_MSG("BindingsClauseOpt: cannot create bindings");
  } else {
    if((yyvsp[(4) - (5)].seq))
      raptor_free_sequence((yyvsp[(4) - (5)].seq));

    (yyval.bindings) = NULL;
  }
}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 2603 "./sparql_parser.y"
    {
  (yyval.bindings) = NULL;
}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 2611 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarList 1: sequence push failed");
  }
}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 2620 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_variable,
                           (raptor_data_print_handler)rasqal_variable_print);
  if(!(yyval.seq))
    YYERROR_MSG("VarList 2: cannot create seq");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarList 3: sequence push failed");
  }
}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 2637 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 2641 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 2649 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].row))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("BindingsRowList 1: sequence push failed");
  } else {
    int size = raptor_sequence_size((yyval.seq));
    (yyvsp[(2) - (2)].row)->offset = size-1;
  }
}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 2661 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_row,
                           (raptor_data_print_handler)rasqal_row_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].row))
      rasqal_free_row((yyvsp[(1) - (1)].row));

    YYERROR_MSG("BindingsRowList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].row))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("BindingsRowList 2: sequence push failed");
  }
}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 2681 "./sparql_parser.y"
    {
  (yyval.row) = NULL;
  if((yyvsp[(2) - (3)].seq)) {
    int size;
    rasqal_row* row;
    int i;
    
    size = raptor_sequence_size((yyvsp[(2) - (3)].seq));

    row = rasqal_new_row_for_size(((rasqal_query*)rq)->world, size);
    if(!row) {
      YYERROR_MSG("BindingsRow: cannot create row");
    } else {
      for(i = 0; i < size; i++) {
        rasqal_literal* value = (rasqal_literal*)raptor_sequence_delete_at((yyvsp[(2) - (3)].seq), i);
        rasqal_row_set_value_at(row, i, value);
      }
    }
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
    
    (yyval.row) = row;
  }
}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 2705 "./sparql_parser.y"
    {
  (yyval.row) = NULL;
}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 2713 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 2722 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 2740 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].name), 
	                         NULL /* language */,
                                 NULL /* dt uri */, NULL /* dt_qname */);
}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 2746 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (2)].name), 
	                         (const char*)(yyvsp[(2) - (2)].name),
                                 NULL /* dt uri */, NULL /* dt_qname */);
}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 2752 "./sparql_parser.y"
    {
  raptor_uri* dt_uri = raptor_uri_copy(rasqal_literal_as_uri((yyvsp[(3) - (3)].literal)));
  (yyval.literal) = rasqal_new_string_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (3)].name), 
	                         NULL /* language */,
                                 dt_uri, NULL /* dt_qname */);
  rasqal_free_literal((yyvsp[(3) - (3)].literal));
}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 2764 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2768 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2772 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2776 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2780 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2792 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (3)].graph_pattern);
}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2796 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (3)].graph_pattern);
}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2807 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GroupGraphPattern\n  TriplesBlockOpt=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphpatternListOpt=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  if(!(yyvsp[(1) - (2)].formula) && !(yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, NULL, NULL);
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GroupGraphPattern: cannot create group gp");
  } else {
    if((yyvsp[(1) - (2)].formula)) {
      formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq,
                                                               (yyvsp[(1) - (2)].formula));
      if(!formula_gp) {
        if((yyvsp[(2) - (2)].graph_pattern))
          rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
        YYERROR_MSG("GroupGraphPattern: cannot create formula_gp");
      }
    }

    if((yyvsp[(2) - (2)].graph_pattern)) {
      (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
      if(formula_gp && raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, formula_gp)) {
        rasqal_free_graph_pattern((yyval.graph_pattern));
        (yyval.graph_pattern) = NULL;
        YYERROR_MSG("GroupGraphPattern: sequence push failed");
      }
    } else
      (yyval.graph_pattern) = formula_gp;
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2865 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlockOpt 1\n  TriplesBlock=");
  if((yyvsp[(1) - (1)].formula))
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 2878 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 2891 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListOpt\n  GraphPatternListOpt=");
  if((yyvsp[(1) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphPatternList=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) =  ((yyvsp[(1) - (2)].graph_pattern) ? (yyvsp[(1) - (2)].graph_pattern) : (yyvsp[(2) - (2)].graph_pattern));
  if((yyvsp[(1) - (2)].graph_pattern) && (yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = (yyvsp[(1) - (2)].graph_pattern);
    if(rasqal_graph_patterns_join((yyval.graph_pattern), (yyvsp[(2) - (2)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GraphPatternListOpt: sequence join failed");
    }
    rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after grouping graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 2928 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 2932 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2945 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternList\n  GraphPatternListFilter=");
  if((yyvsp[(1) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].formula)) {
    formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq, 
                                                             (yyvsp[(3) - (3)].formula));
    if(!formula_gp) {
      if((yyvsp[(1) - (3)].graph_pattern))
        rasqal_free_graph_pattern((yyvsp[(1) - (3)].graph_pattern));
      YYERROR_MSG("GraphPatternList: cannot create formula_gp");
    }
  }
  (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (3)].graph_pattern), formula_gp);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternList: cannot create sequence");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2993 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 1\n  GraphPatternNotTriples=");
  if((yyvsp[(1) - (1)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (1)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 3006 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 2\n  Filter=");
  if((yyvsp[(1) - (1)].expr))
    rasqal_expression_print((yyvsp[(1) - (1)].expr), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = rasqal_new_filter_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (1)].expr));
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternListFilter 2: cannot create graph pattern");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 3040 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlock\n  TriplesSameSubject=");
  if((yyvsp[(1) - (3)].formula))
    rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  (yyval.formula) =  ((yyvsp[(1) - (3)].formula) ? (yyvsp[(1) - (3)].formula) : (yyvsp[(3) - (3)].formula));
  if((yyvsp[(1) - (3)].formula) && (yyvsp[(3) - (3)].formula)) {
    /* $1 and $3 are freed as necessary */
    (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (3)].formula), (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(1) - (3)].formula))
      YYERROR_MSG("TriplesBlock: formula join failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 3071 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 3079 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 3083 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 3087 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 3091 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 3095 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 3099 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 3103 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 3111 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PatternElementForms 4\n  graphpattern=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = NULL;

  if((yyvsp[(2) - (2)].graph_pattern)) {
    raptor_sequence *seq;

    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      YYERROR_MSG("OptionalGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(2) - (2)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("OptionalGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_OPTIONAL);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("OptionalGraphPattern: cannot create graph pattern");
      }
    }
  }
}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 3150 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern 2\n  varoruri=");
  rasqal_literal_print((yyvsp[(2) - (3)].literal), DEBUG_FH);
  fprintf(DEBUG_FH, ", graphpattern=");
  if((yyvsp[(3) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].graph_pattern)) {
    raptor_sequence *seq;

    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
      YYERROR_MSG("GraphGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(3) - (3)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("GraphGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_GRAPH);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
        else
          rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (3)].literal));
      }
    }
  }


#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 3200 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = rasqal_new_single_graph_pattern((rasqal_query*)rq,
                                       RASQAL_GRAPH_PATTERN_OPERATOR_SERVICE,
                                       (yyvsp[(4) - (4)].graph_pattern));
  if((yyval.graph_pattern)) {
    (yyval.graph_pattern)->silent = ((yyvsp[(2) - (4)].integer) & RASQAL_UPDATE_FLAGS_SILENT) ? 1 : 0;

    (yyval.graph_pattern)->origin = (yyvsp[(3) - (4)].literal);
    (yyvsp[(3) - (4)].literal) = NULL;
  } else if((yyvsp[(3) - (4)].literal))
    rasqal_free_literal((yyvsp[(3) - (4)].literal));
}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 3217 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = rasqal_new_single_graph_pattern((rasqal_query*)rq,
                                       RASQAL_GRAPH_PATTERN_OPERATOR_MINUS,
                                       (yyvsp[(2) - (2)].graph_pattern));
}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 3227 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(3) - (3)].graph_pattern);
  if(raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, (yyvsp[(1) - (3)].graph_pattern))) {
    rasqal_free_graph_pattern((yyval.graph_pattern));
    (yyval.graph_pattern) = NULL;
    YYERROR_MSG("GroupOrUnionGraphPattern: sequence push failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "UnionGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif
}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 3242 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 3249 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (3)].graph_pattern);
  if((yyvsp[(3) - (3)].graph_pattern))
    if(raptor_sequence_push((yyval.graph_pattern)->graph_patterns, (yyvsp[(3) - (3)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GroupOrUnionGraphPatternList 1: sequence push failed");
    }
}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 3259 "./sparql_parser.y"
    {
  raptor_sequence *seq;
  seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                            (raptor_data_print_handler)rasqal_graph_pattern_print);
  if(!seq) {
    if((yyvsp[(1) - (1)].graph_pattern))
      rasqal_free_graph_pattern((yyvsp[(1) - (1)].graph_pattern));
    YYERROR_MSG("GroupOrUnionGraphPatternList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].graph_pattern))
    if(raptor_sequence_push(seq, (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence(seq);
      YYERROR_MSG("GroupOrUnionGraphPatternList 2: sequence push failed");
    }
  (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                              seq,
                                              RASQAL_GRAPH_PATTERN_OPERATOR_UNION);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GroupOrUnionGraphPatternList 1: cannot create gp");
}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 3284 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.graph_pattern) = NULL;
  if((yyvsp[(3) - (6)].variable) && (yyvsp[(5) - (6)].expr)) {
    if(sparql->experimental)
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(3) - (6)].variable), (yyvsp[(5) - (6)].expr));
    else {
      sparql_syntax_error((rasqal_query*)rq,
                          "LET can only be used with LAQRS");
      YYERROR;
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 3305 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.graph_pattern) = NULL;
  if((yyvsp[(3) - (6)].expr) && (yyvsp[(5) - (6)].variable)) {
    if(!sparql->sparql11_query) {
      sparql_syntax_error((rasqal_query*)rq,
                          "BIND cannot be used with SPARQL 1.0");
      YYERROR;
    } else {
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(5) - (6)].variable), (yyvsp[(3) - (6)].expr));
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 3326 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 3334 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 3338 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 3342 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 3349 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 3353 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 3361 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (6)].literal));
  
  if(!(yyvsp[(4) - (6)].seq)) {
    (yyvsp[(4) - (6)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
    if(!(yyvsp[(4) - (6)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (6)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(4) - (6)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(4) - (6)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
    raptor_free_sequence((yyvsp[(4) - (6)].seq));
  } else {
    unsigned int flags = 0;
    if((yyvsp[(3) - (6)].uinteger))
      flags |= 1;
    
    (yyval.expr) = rasqal_new_function_expression(((rasqal_query*)rq)->world, 
                                        uri, (yyvsp[(4) - (6)].seq), (yyvsp[(5) - (6)].seq) /* params */,
                                        flags);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
  }
  rasqal_free_literal((yyvsp[(1) - (6)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 3400 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (3)].literal));
  
  if(!(yyvsp[(2) - (3)].seq)) {
    (yyvsp[(2) - (3)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
    if(!(yyvsp[(2) - (3)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (3)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(2) - (3)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(2) - (3)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  } else {
    (yyval.expr) = rasqal_new_function_expression(((rasqal_query*)rq)->world,
                                        uri, (yyvsp[(2) - (3)].seq), NULL /* params */,
                                        0 /* flags */);
  }
  rasqal_free_literal((yyvsp[(1) - (3)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 3434 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COALESCE cannot be used with SPARQL 1.0");
    YYERROR;
  }
  
  if(!(yyvsp[(2) - (2)].seq)) {
    (yyvsp[(2) - (2)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
    if(!(yyvsp[(2) - (2)].seq))
      YYERROR_MSG("FunctionCall: cannot create sequence");
  }

  (yyval.expr) = rasqal_new_expr_seq_expression(((rasqal_query*)rq)->world, 
                                      RASQAL_EXPR_COALESCE, (yyvsp[(2) - (2)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("Coalesce: cannot create expr");
}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 3462 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 3469 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if((yyvsp[(3) - (3)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 1: sequence push failed");
    }
}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 3479 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("ArgListNoBraces 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 2: sequence push failed");
    }
}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 3495 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 3503 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 3511 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 3515 "./sparql_parser.y"
    {
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                           (raptor_data_print_handler)rasqal_triple_print);
  if(!(yyval.seq)) {
    YYERROR_MSG("ConstructTriplesOpt: cannot create sequence");
  }
}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 3527 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
 
  if((yyvsp[(1) - (3)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (3)].formula)->triples;
    (yyvsp[(1) - (3)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (3)].formula));
  }
  
  if((yyvsp[(3) - (3)].seq)) {
    if(!(yyval.seq)) {
      (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                               (raptor_data_print_handler)rasqal_triple_print);
      if(!(yyval.seq)) {
        raptor_free_sequence((yyvsp[(3) - (3)].seq));
        YYERROR_MSG("ConstructTriples: cannot create sequence");
      }
    }

    if(raptor_sequence_join((yyval.seq), (yyvsp[(3) - (3)].seq))) {
      raptor_free_sequence((yyvsp[(3) - (3)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ConstructTriples: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(3) - (3)].seq));
  }

 }
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 3557 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
  
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (1)].formula)->triples;
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
  
}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 3572 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 1\n  subject=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 1: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 3616 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 2\n  TriplesNode=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 2: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 3664 "./sparql_parser.y"
    {
  int i;
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PropertyList 1\n  Verb=");
  rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  ObjectList=");
  rasqal_formula_print((yyvsp[(2) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  PropertyListTail=");
  if((yyvsp[(3) - (3)].formula) != NULL)
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif
  
  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, " empty ObjectList not processed\n");
#endif
  } else if((yyvsp[(1) - (3)].formula) && (yyvsp[(2) - (3)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;
    rasqal_literal *predicate = (yyvsp[(1) - (3)].formula)->value;
    rasqal_formula *formula;
    rasqal_triple *t2;
    int size;
    
    formula = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!formula) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create formula");
    }
    formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                           (raptor_data_print_handler)rasqal_triple_print);
    if(!formula->triples) {
      rasqal_free_formula(formula);
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create sequence");
    }

    /* non-empty property list, handle it  */
    size = raptor_sequence_size(seq);
    for(i = 0; i < size; i++) {
      t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(!t2->predicate)
        t2->predicate = (rasqal_literal*)rasqal_new_literal_from_literal(predicate);
    }
  
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution ObjectList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    while(raptor_sequence_size(seq)) {
      t2 = (rasqal_triple*)raptor_sequence_unshift(seq);
      if(raptor_sequence_push(formula->triples, t2)) {
        rasqal_free_formula(formula);
        rasqal_free_formula((yyvsp[(1) - (3)].formula));
        rasqal_free_formula((yyvsp[(2) - (3)].formula));
        if((yyvsp[(3) - (3)].formula))
          rasqal_free_formula((yyvsp[(3) - (3)].formula));
        YYERROR_MSG("PropertyList 1: sequence push failed");
      }
    }

    (yyvsp[(3) - (3)].formula) = rasqal_formula_join(formula, (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(3) - (3)].formula)) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      YYERROR_MSG("PropertyList 1: formula join failed");
    }

#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after appending ObjectList=");
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif

    rasqal_free_formula((yyvsp[(2) - (3)].formula));
  }

  if((yyvsp[(1) - (3)].formula))
    rasqal_free_formula((yyvsp[(1) - (3)].formula));

  (yyval.formula) = (yyvsp[(3) - (3)].formula);
}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 3762 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 3766 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 3774 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 3778 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 3786 "./sparql_parser.y"
    {
  rasqal_formula *formula;
  rasqal_triple *triple;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "ObjectList 1\n");
  fprintf(DEBUG_FH, "  Object=\n");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  ObjectTail=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty ObjectTail\n");
#endif

  formula = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!formula) {
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create formula");
  }
  
  formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                         (raptor_data_print_handler)rasqal_triple_print);
  if(!formula->triples) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create sequence");
  }

  triple = rasqal_new_triple(NULL, NULL, (yyvsp[(1) - (2)].formula)->value);
  (yyvsp[(1) - (2)].formula)->value = NULL; /* value now owned by triple */
  if(!triple) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create triple");
  }

  if(raptor_sequence_push(formula->triples, triple)) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: sequence push failed");
  }

  (yyval.formula) = rasqal_formula_join(formula, (yyvsp[(1) - (2)].formula));
  if(!(yyval.formula)) {
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: formula join $1 failed");
  }

  (yyval.formula) = rasqal_formula_join((yyval.formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("ObjectList: formula join $2 failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  objectList is now ");
  if((yyval.formula))
    raptor_sequence_print((yyval.formula)->triples, DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 3864 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 3868 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 3876 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 3884 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("Verb 1: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 3894 "./sparql_parser.y"
    {
  raptor_uri *uri;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "verb Verb=rdf:type (a)\n");
#endif

  uri = raptor_new_uri_for_rdf_concept(((rasqal_query*)rq)->world->raptor_world_ptr,
                                       (const unsigned char*)"type");
  if(!uri)
    YYERROR_MSG("Verb 2: uri for rdf concept type failed");
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    raptor_free_uri(uri);
    YYERROR_MSG("Verb 2: cannot create formula");
  }
  (yyval.formula)->value = rasqal_new_uri_literal(((rasqal_query*)rq)->world, uri);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("Verb 2: cannot create uri literal");
  }
}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 3922 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 3926 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 3934 "./sparql_parser.y"
    {
  int i;
  const unsigned char *id;

  if((yyvsp[(2) - (3)].formula) == NULL) {
    (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!(yyval.formula))
      YYERROR_MSG("BlankNodePropertyList: cannot create formula");
  } else {
    (yyval.formula) = (yyvsp[(2) - (3)].formula);
    if((yyval.formula)->value) {
      rasqal_free_literal((yyval.formula)->value);
      (yyval.formula)->value = NULL;
    }
  }
  
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodeProperyList: cannot create bnodeid");
  }

  (yyval.formula)->value = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                        RASQAL_LITERAL_BLANK, id);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodePropertyList: cannot create literal");
  }

  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  } else {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;

    /* non-empty property list, handle it  */
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    for(i = 0; i<raptor_sequence_size(seq); i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      
      t2->subject = (rasqal_literal*)rasqal_new_literal_from_literal((yyval.formula)->value);
    }

#if RASQAL_DEBUG > 1
    fprintf(DEBUG_FH, "  after substitution formula=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }
}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 4001 "./sparql_parser.y"
    {
  int i;
  rasqal_query* rdf_query = (rasqal_query*)rq;
  rasqal_literal* first_identifier = NULL;
  rasqal_literal* rest_identifier = NULL;
  rasqal_literal* object = NULL;
  rasqal_literal* blank = NULL;

#if RASQAL_DEBUG > 1
  char const *errmsg;
  #define YYERR_MSG_GOTO(label,msg) do { errmsg = msg; goto label; } while(0)
#else
  #define YYERR_MSG_GOTO(label,ignore) goto label
#endif

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "Collection\n  GraphNodeListNotEmpty=");
  raptor_sequence_print((yyvsp[(2) - (3)].seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif

  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create formula");

  (yyval.formula)->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                    (raptor_data_print_handler)rasqal_triple_print);
  if(!(yyval.formula)->triples)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create sequence");

  first_identifier = rasqal_new_uri_literal(rdf_query->world,
                                            raptor_uri_copy(rdf_query->world->rdf_first_uri));
  if(!first_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot first_identifier");
  
  rest_identifier = rasqal_new_uri_literal(rdf_query->world,
                                           raptor_uri_copy(rdf_query->world->rdf_rest_uri));
  if(!rest_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create rest_identifier");
  
  object = rasqal_new_uri_literal(rdf_query->world,
                                  raptor_uri_copy(rdf_query->world->rdf_nil_uri));
  if(!object)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create nil object");

  for(i = raptor_sequence_size((yyvsp[(2) - (3)].seq))-1; i >= 0; i--) {
    rasqal_formula* f = (rasqal_formula*)raptor_sequence_get_at((yyvsp[(2) - (3)].seq), i);
    rasqal_triple *t2;
    const unsigned char *blank_id = NULL;

    blank_id = rasqal_query_generate_bnodeid(rdf_query, NULL);
    if(!blank_id)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnodeid");

    blank = rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, blank_id);
    if(!blank)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnode");

    /* Move existing formula triples */
    if(f->triples)
      if(raptor_sequence_join((yyval.formula)->triples, f->triples))
        YYERR_MSG_GOTO(err_Collection, "Collection: sequence join failed");

    /* add new triples we needed */
    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(first_identifier),
                           rasqal_new_literal_from_literal(f->value));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(rest_identifier),
                           rasqal_new_literal_from_literal(object));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple 2");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: sequence push 2 failed");

    rasqal_free_literal(object);
    object=blank;
    blank = NULL;
  }

  /* free sequence of formulas just processed */
  raptor_free_sequence((yyvsp[(2) - (3)].seq));
  
  (yyval.formula)->value=object;
  
#if RASQAL_DEBUG > 1
  fprintf(DEBUG_FH, "  after substitution collection=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif

  rasqal_free_literal(first_identifier);
  rasqal_free_literal(rest_identifier);

  break; /* success */

  err_Collection:
  
  if(blank)
    rasqal_free_literal(blank);
  if(object)
    rasqal_free_literal(object);
  if(rest_identifier)
    rasqal_free_literal(rest_identifier);
  if(first_identifier)
    rasqal_free_literal(first_identifier);
  if((yyvsp[(2) - (3)].seq))
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  if((yyval.formula)) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 4128 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  char const *errmsg;

  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 1\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
  if((yyvsp[(1) - (2)].seq)) {
    fprintf(DEBUG_FH, "  GraphNodeListNotEmpty=");
    raptor_sequence_print((yyvsp[(1) - (2)].seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty GraphNodeListNotEmpty\n");
#endif

  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(!(yyval.seq)) {
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
    if(!(yyval.seq))
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty: cannot create formula");
  }
  
  if((yyvsp[(2) - (2)].formula)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].formula))) {
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty 1: sequence push failed");
    }
    (yyvsp[(2) - (2)].formula) = NULL;
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  itemList is now ");
    raptor_sequence_print((yyval.seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }

  break; /* success */

  err_GraphNodeListNotEmpty:
  if((yyvsp[(2) - (2)].formula))
    rasqal_free_formula((yyvsp[(2) - (2)].formula));
  if((yyval.seq)) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 4181 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 2\n");
  if((yyvsp[(1) - (1)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
#endif

  if(!(yyvsp[(1) - (1)].formula))
    (yyval.seq) = NULL;
  else {
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
    if(!(yyval.seq)) {
      rasqal_free_formula((yyvsp[(1) - (1)].formula));
      YYERROR_MSG("GraphNodeListNotEmpty 2: cannot create sequence");
    }
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].formula))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GraphNodeListNotEmpty 2: sequence push failed");
    }
  }
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  GraphNodeListNotEmpty is now ");
  raptor_sequence_print((yyval.seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 4218 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 4222 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 4230 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERROR_MSG("VarOrTerm 1: cannot create formula");
  (yyval.formula)->value = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("VarOrTerm 1: cannot create literal");
  }
}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 4242 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("VarOrTerm 2: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 4255 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.literal))
    YYERROR_MSG("VarOrIRIref: cannot create literal");
}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 4261 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 4269 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 4273 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 4280 "./sparql_parser.y"
    {
  (yyval.variable) = rasqal_variables_table_add(((rasqal_query*)rq)->vars_table,
                                  RASQAL_VARIABLE_TYPE_NORMAL, (yyvsp[(1) - (1)].name), NULL);
  if(!(yyval.variable))
    YYERROR_MSG("VarName: cannot create var");
}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 4291 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 4295 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 4299 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "... AS varname is deprecated LAQRS syntax, use ... AS ?varname");
}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 4309 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 4313 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 4317 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 4321 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 4325 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 4329 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, 
                              raptor_uri_copy(((rasqal_query*)rq)->world->rdf_nil_uri));
  if(!(yyval.literal))
    YYERROR_MSG("GraphTerm: cannot create literal");
}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 4339 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 4347 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_OR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalOrExpression: cannot create expr");
}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 4354 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 4362 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalAndExpression: cannot create expr");
;
}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 4370 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 4379 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_EQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 1: cannot create expr");
}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 4386 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NEQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 2: cannot create expr");
}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 4393 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 3: cannot create expr");
}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 4400 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 4: cannot create expr");
}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 4407 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 5: cannot create expr");
}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 4414 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 6: cannot create expr");
}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 4421 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IN, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].seq));
}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 4426 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NOT_IN, (yyvsp[(1) - (4)].expr), (yyvsp[(4) - (4)].seq));
}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 4431 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 4440 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 1: cannot create expr");
}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 4447 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MINUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 2: cannot create expr");
}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 4454 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 3: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 4: cannot create expr");
}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 4467 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 5: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 6: cannot create expr");
}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 4480 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 4487 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STAR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 1: cannot create expr");
}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 4494 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SLASH, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 2: cannot create expr");
}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 4501 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 4509 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BANG, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 1: cannot create expr");
}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 4516 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 4520 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_UMINUS, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 3: cannot create expr");
}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 4527 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 4541 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 4545 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 4549 "./sparql_parser.y"
    {
  /* Grammar has IRIrefOrFunction here which is "IRIref ArgList?"
   * and essentially shorthand for FunctionCall | IRIref.  The Rasqal
   * SPARQL lexer distinguishes these for us with IRIrefBrace.
   * IRIref is covered below by GraphTerm.
   */
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 4558 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].literal));
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 4: cannot create expr");
}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 4564 "./sparql_parser.y"
    {
  rasqal_literal *l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("PrimaryExpression 5: cannot create literal");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 5: cannot create expr");
}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 4574 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 4582 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (3)].expr);
}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 4590 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 1: cannot create expr");
}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 4597 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANG, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 2: cannot create expr");
}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 4604 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANGMATCHES, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 3: cannot create expr");
}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 4611 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_DATATYPE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 4: cannot create expr");
}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 4618 "./sparql_parser.y"
    {
  rasqal_literal *l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
  if(!l)
    YYERROR_MSG("BuiltInCall 5: cannot create literal");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("BuiltInCall 6: cannot create literal expr");
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BOUND, e);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7: cannot create expr");
}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 4633 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7a: cannot create expr");
}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 4640 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7b: cannot create expr");
}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 4647 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7c: cannot create expr");
}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 4654 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, NULL);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7d: cannot create expr");
}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 4661 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_RAND);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7e: cannot create expr");
}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 4668 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_ABS, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7f: cannot create expr");
}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 4675 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_CEIL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7g: cannot create expr");
}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 4682 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_FLOOR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7h: cannot create expr");
}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 4689 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_ROUND, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7i: cannot create expr");
}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 4696 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_MD5, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7j: cannot create expr");
}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 4703 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA1, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7k: cannot create expr");
}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 4710 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA224, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7l: cannot create expr");
}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 4717 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA256, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7m: cannot create expr");
}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 4724 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA384, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7n: cannot create expr");
}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 4731 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_SHA512, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7o: cannot create expr");
}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 4738 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 4742 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 4746 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IF, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7e: cannot create expr");
}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 4753 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRLANG, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7f: cannot create expr");
}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 4760 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRDT, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7g: cannot create expr");
}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 4767 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SAMETERM, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 8: cannot create expr");
}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 4774 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISURI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 9: cannot create expr");
}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 4781 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISBLANK, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 10: cannot create expr");
}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 4788 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISLITERAL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 11: cannot create expr");
}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 4795 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISNUMERIC, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 12: cannot create expr");
}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 4802 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 4806 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 4810 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 4817 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRLEN, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRLEN() expr");
}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 4824 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SUBSTR, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create SUBSTR() expr");
}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 4831 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SUBSTR, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create SUBSTR() expr");
}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 4838 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_UCASE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create UCASE() expr");
}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 4845 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LCASE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create LCASE() expr");
}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 4852 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRSTARTS, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRSTARTS() expr");
}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 4859 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRENDS, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRENDS() expr");
}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 4866 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_CONTAINS, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create YEAR expr");
}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 4873 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ENCODE_FOR_URI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create ENCODE_FOR_URI() expr");
}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 4880 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_expr_seq_expression(((rasqal_query*)rq)->world, 
                                      RASQAL_EXPR_CONCAT, (yyvsp[(3) - (4)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create CONCAT() expr");
}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 4887 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRBEFORE, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRBEFORE() expr");
}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 4894 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRAFTER, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create STRAFTER() expr");
}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 4901 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REPLACE, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create REPLACE() expr");
}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 4908 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_4op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REPLACE, (yyvsp[(3) - (10)].expr), (yyvsp[(5) - (10)].expr), (yyvsp[(7) - (10)].expr), (yyvsp[(9) - (10)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("StringExpression: cannot create REPLACE() expr");
}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 4919 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 1: cannot create expr");
}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 4926 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 2: cannot create expr");
}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 4937 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_YEAR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create YEAR expr");
}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 4944 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MONTH, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create MONTH expr");
}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 4951 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_DAY, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create DAY expr");
}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 4958 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_HOURS, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create HOURS expr");
}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 4965 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MINUTES, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create MINUTES expr");
}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 4972 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SECONDS, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create SECONDS expr");
}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 4979 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_TIMEZONE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create TIMEZONE expr");
}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 4986 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_TZ, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeBuiltinAccessors: cannot create TZ expr");
}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 4997 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(sparql->experimental) {
    (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_CURRENT_DATETIME);
    if(!(yyval.expr))
      YYERROR_MSG("DatetimeExtensions: cannot create CURRENT_DATETIME() expr");
  } else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "CURRENT_DATETIME() can only used with LAQRS");
    YYERROR;
  }
}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 5014 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);
  
  (yyval.expr) = NULL;
  if(!sparql->sparql11_query) {
    sparql_syntax_error((rasqal_query*)rq,
                        "NOW() cannot be used with SPARQL 1.0");
    YYERROR;
  }
  
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_NOW);
  if(!(yyval.expr))
    YYERROR_MSG("DatetimeExtensions: cannot create NOW()");

}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 5032 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(sparql->experimental) {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_FROM_UNIXTIME, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("DatetimeExtensions: cannot create FROM_UNIXTIME() expr");
  } else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "FROM_UNIXTIME() can only used with LAQRS");
    YYERROR;
  }
  
}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 5050 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.expr) = NULL;
  if(sparql->experimental) {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_TO_UNIXTIME, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("DatetimeExtensions: cannot create TO_UNIXTIME() expr");
  } else {
    sparql_syntax_error((rasqal_query*)rq, 
                        "TO_UNIXTIME() can only used with LAQRS");
    YYERROR;
  }
  
}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 5075 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 1: cannot create literal");
}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 5081 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 5101 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 5105 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 5109 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 5116 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 5120 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 5124 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 5132 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 5136 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 5140 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 5148 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 5152 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 5156 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 5168 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 1: cannot create literal");
}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 5174 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 5194 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 1: cannot create literal");
}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 5200 "./sparql_parser.y"
    {
  const unsigned char *id;
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id)
    YYERROR_MSG("BlankNode 2: cannot create bnodeid");
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, id);
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 2: cannot create literal");
}
    break;



/* Line 1455 of yacc.c  */
#line 10281 "sparql_parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 5219 "./sparql_parser.y"



/* Support functions */


/* This is declared in sparql_lexer.h but never used, so we always get
 * a warning unless this dummy code is here.  Used once below in an error case.
 */
static int yy_init_globals (yyscan_t yyscanner ) { return 0; }


/**
 * rasqal_sparql_query_language_init - Initialise the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static int
rasqal_sparql_query_language_init(rasqal_query* rdf_query, const char *name)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rdf_query->context;

  rdf_query->compare_flags = RASQAL_COMPARE_XQUERY;

  /* All the sparql query families support this */
  rqe->sparql10 = 1;
  rqe->sparql_query = 1;
  /* SPARQL 1.1 is the default */
  rqe->sparql11_query = 1;
  rqe->sparql11_aggregates = 1;
  rqe->sparql11_property_paths = 1;
  rqe->sparql11_update = 1;

  /* SPARQL 1.0 disables SPARQL 1.1 features */
  if(!strncmp(name, "sparql10", 8)) {
    rqe->sparql11_query = 0;
    rqe->sparql11_aggregates = 0;
    rqe->sparql11_property_paths = 0;
    rqe->sparql11_update = 0;
  }

  if(!strcmp(name, "sparql11-query")) {
    /* No update if SPARQL 1.1 query */
    rqe->sparql11_update = 0;
  }
  
  if(!strcmp(name, "sparql11-update")) {
    /* No query if SPARQL 1.1 update */
    rqe->sparql_query = 0;
    rqe->sparql11_query = 0;
  }
  
  /* LAQRS for experiments */
  if(!strcmp(name, "laqrs"))
    rqe->experimental = 1;

  return 0;
}


/**
 * rasqal_sparql_query_language_terminate - Free the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static void
rasqal_sparql_query_language_terminate(rasqal_query* rdf_query)
{
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)rdf_query->context;

  if(sparql && sparql->scanner_set) {
    sparql_lexer_lex_destroy(sparql->scanner);
    sparql->scanner_set = 0;
  }

}


static int
rasqal_sparql_query_language_prepare(rasqal_query* rdf_query)
{
  /* rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)rdf_query->context; */
  int rc;
  
  if(!rdf_query->query_string)
    return 1;
  
  rc=sparql_parse(rdf_query);
  if(rc)
    return rc;

  /* FIXME - should check remaining query parts  */
  if(rasqal_sequence_has_qname(rdf_query->triples) ||
     rasqal_sequence_has_qname(rdf_query->constructs) ||
     rasqal_query_constraints_has_qname(rdf_query)) {
    sparql_query_error(rdf_query, "SPARQL query has unexpanded QNames");
    return 1;
  }

  /* SPARQL: Turn [] into anonymous variables */
  if(rasqal_query_build_anonymous_variables(rdf_query))
    return 1;
  
  /* SPARQL: Expand 'SELECT *' */
  if(rasqal_query_expand_wildcards(rdf_query,
                                   rasqal_query_get_projection(rdf_query)))
    return 1;
  
  return 0;
}


static int
sparql_parse(rasqal_query* rq)
{
  rasqal_sparql_query_language* rqe;
  raptor_locator *locator=&rq->locator;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(!rq->query_string)
    return yy_init_globals(NULL); /* 0 but a way to use yy_init_globals */

  locator->line = 1;
  locator->column = -1; /* No column info */
  locator->byte = -1; /* No bytes info */

#if RASQAL_DEBUG > 2
  sparql_parser_debug = 1;
#endif

  rqe->lineno = 1;

  if(sparql_lexer_lex_init(&rqe->scanner))
    return 1;
  rqe->scanner_set = 1;

  sparql_lexer_set_extra(((rasqal_query*)rq), rqe->scanner);

  (void)sparql_lexer__scan_buffer((char*)rq->query_string,
                                  rq->query_string_length, rqe->scanner);

  rqe->error_count = 0;

  sparql_parser_parse(rq);

  sparql_lexer_lex_destroy(rqe->scanner);
  rqe->scanner_set = 0;

  /* Parsing failed */
  if(rq->failed)
    return 1;
  
  return 0;
}


static void
sparql_query_error(rasqal_query *rq, const char *msg)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  rq->failed = 1;
  rasqal_log_error_simple(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                          &rq->locator, "%s", msg);
}


static void
sparql_query_error_full(rasqal_query *rq, const char *message, ...)
{
  va_list arguments;
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);

  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);

  va_end(arguments);
}


int
sparql_syntax_error(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return 0;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rp->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);
  va_end(arguments);

  return 0;
}


int
sparql_syntax_warning(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  if(RASQAL_WARNING_LEVEL_QUERY_SYNTAX < rq->world->warning_level)
    return 0;
  
  rqe = (rasqal_sparql_query_language*)rq->context;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_WARN,
                           &rq->locator, message, arguments);
  va_end(arguments);

  return 0;
}


static int
rasqal_sparql_query_language_iostream_write_escaped_counted_string(rasqal_query* query,
                                                                   raptor_iostream* iostr,
                                                                   const unsigned char* string,
                                                                   size_t len)
{
  const char delim = '"';
  
  raptor_iostream_write_byte(delim, iostr);
  if(raptor_string_ntriples_write(string, len, delim, iostr))
    return 1;
  
  raptor_iostream_write_byte(delim, iostr);

  return 0;
}


static const char* const sparql_names[] = { "sparql10", NULL};

static const raptor_type_q sparql_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql_names;

  factory->desc.mime_types = sparql_types;

  factory->desc.label = "SPARQL 1.0 W3C RDF Query Language";

  factory->desc.uri_strings = NULL;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_sparql(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_sparql_query_language_register_factory);
}


static const char* const sparql11_names[] = { "sparql", "sparql11", NULL };


static const char* const sparql11_uri_strings[] = {
  "http://www.w3.org/TR/rdf-sparql-query/",
  NULL
};

static const raptor_type_q sparql11_types[] = {
  { "application/sparql", 18, 10}, 
  { NULL, 0, 0}
};


static int
rasqal_sparql11_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_names;

  factory->desc.mime_types = sparql11_types;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Query and Update Languages";

  /* What URI describes Query and Update languages? */
  factory->desc.uri_strings = sparql11_uri_strings;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


static const char* const sparql11_query_names[] = { "sparql11-query", NULL };

static const char* const sparql11_query_uri_strings[] = {
  "http://www.w3.org/TR/2010/WD-sparql11-query-20101014/",
  NULL
};

static const raptor_type_q sparql11_query_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql11_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_query_names;

  factory->desc.mime_types = sparql11_query_types;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Query Language";

  factory->desc.uri_strings = sparql11_query_uri_strings;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


static const char* const sparql11_update_names[] = { "sparql11-update", NULL };

static const char* const sparql11_update_uri_strings[] = {
  "http://www.w3.org/TR/2010/WD-sparql11-update-20101014/",
  NULL
};

static const raptor_type_q sparql11_update_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_sparql11_update_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = sparql11_update_names;

  factory->desc.mime_types = sparql11_update_types;

  factory->desc.label = "SPARQL 1.1 (DRAFT) Update Language";

  factory->desc.uri_strings = sparql11_update_uri_strings;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_sparql11(rasqal_world* world)
{
  if(!rasqal_query_language_register_factory(world,
                                             &rasqal_sparql11_language_register_factory))
    return 1;
  
  if(!rasqal_query_language_register_factory(world,
                                             &rasqal_sparql11_query_language_register_factory))
    return 1;
  
  if(!rasqal_query_language_register_factory(world,
                                             &rasqal_sparql11_update_language_register_factory))
    return 1;
  
  return 0;
}


static const char* const laqrs_names[] = { "laqrs", NULL};

static const raptor_type_q laqrs_types[] = {
  { NULL, 0, 0}
};


static int
rasqal_laqrs_query_language_register_factory(rasqal_query_language_factory *factory)
{
  int rc = 0;

  factory->desc.names = laqrs_names;

  factory->desc.mime_types = laqrs_types;

  factory->desc.label = "LAQRS adds to Querying RDF in SPARQL";

  factory->desc.uri_strings = NULL;

  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;

  return rc;
}


int
rasqal_init_query_language_laqrs(rasqal_world* world)
{
  return !rasqal_query_language_register_factory(world,
                                                 &rasqal_laqrs_query_language_register_factory);
}


#ifdef STANDALONE
#include <stdio.h>
#include <locale.h>
#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifndef HAVE_GETOPT
#include <rasqal_getopt.h>
#endif

#ifdef NEED_OPTIND_DECLARATION
extern int optind;
extern char *optarg;
#endif

#define GETOPT_STRING "di:"

#define SPARQL_FILE_BUF_SIZE 4096

static char query_string[SPARQL_FILE_BUF_SIZE];

int
main(int argc, char *argv[]) 
{
  const char *program = rasqal_basename(argv[0]);
  rasqal_query *query;
  FILE *fh;
  int rc;
  const char *filename = NULL;
  raptor_uri* base_uri = NULL;
  unsigned char *uri_string = NULL;
  const char* query_language = "sparql";
  int usage = 0;
  rasqal_world *world;
  size_t read_len;

  world = rasqal_new_world();
  if(!world || rasqal_world_open(world))
    exit(1);

  filename = getenv("SPARQL_QUERY_FILE");
    
  while(!usage) {
    int c = getopt (argc, argv, GETOPT_STRING);

    if (c == -1)
      break;

    switch (c) {
      case 0:
      case '?': /* getopt() - unknown option */
        usage = 1;
        break;
        
      case 'd':
#if RASQAL_DEBUG > 2
        sparql_parser_debug = 1;
#endif
        break;
  
      case 'i':
        if(optarg) {
          if(rasqal_language_name_check(world, optarg)) {
            query_language = optarg;
          } else {
            fprintf(stderr, "%s: Unknown query language '%s'\n",
                    program, optarg);
            usage = 1;
          }
        }
        break;
    }
  }

  if(!filename) {
    if((argc-optind) != 1) {
      fprintf(stderr, "%s: Too many arguments.\n", program);
      usage = 1;
    } else
      filename = argv[optind];
  }
  
  if(usage) {
    fprintf(stderr, "SPARQL/LAQRS parser test for Rasqal %s\n", 
            rasqal_version_string);
    fprintf(stderr, "USAGE: %s [OPTIONS] SPARQL-QUERY-FILE\n", program);
    fprintf(stderr, "OPTIONS:\n");
#if RASQAL_DEBUG > 2
    fprintf(stderr, " -d           Bison parser debugging\n");
#endif
    fprintf(stderr, " -i LANGUAGE  Set query language\n");
    rc = 1;
    goto tidy;
  }


 fh = fopen(filename, "r");
 if(!fh) {
   fprintf(stderr, "%s: Cannot open file %s - %s\n", program, filename,
           strerror(errno));
   rc = 1;
   goto tidy;
 }
 
  memset(query_string, 0, SPARQL_FILE_BUF_SIZE);
  read_len = fread(query_string, SPARQL_FILE_BUF_SIZE, 1, fh);
  if(read_len < SPARQL_FILE_BUF_SIZE) {
    if(ferror(fh)) {
      fprintf(stderr, "%s: file '%s' read failed - %s\n",
              program, filename, strerror(errno));
      fclose(fh);
      rc = 1;
      goto tidy;
    }
  }
  
  fclose(fh);

  query = rasqal_new_query(world, query_language, NULL);
  rc = 1;
  if(query) {
    uri_string = raptor_uri_filename_to_uri_string(filename);

    if(uri_string) {
      base_uri = raptor_new_uri(world->raptor_world_ptr, uri_string);

      if(base_uri) {
        rc = rasqal_query_prepare(query, (const unsigned char*)query_string, 
                                  base_uri);

        if(!rc)
          rasqal_query_print(query, stdout);
      }
    }
  }

  tidy:
  if(query)
    rasqal_free_query(query);

  if(base_uri)
    raptor_free_uri(base_uri);

  if(uri_string)
    raptor_free_memory(uri_string);

  if(world)
    rasqal_free_world(world);

  return rc;
}
#endif

